// Two Rivers
// a random map for AOE3: The War Chiefs
// by RF_Gandalf

include "mercenaries.xs";

void main(void)
{  
   // Text
   rmSetStatusText("",0.01);

// Set up for variables
   string baseType = "";
   string cliffType = "";
   string forestType = "";
   string riverType = "";
   string treeType = "";
   string deerType = "";
   string deer2Type = "";
   string sheepType = "";
   string centerHerdType = "";
   string native1Name = "";
   string native2Name = "";
   string patchMixType = "";

// Pick pattern for trees, terrain, features, etc.
   int patternChance = rmRandInt(1,24);   
   int variantChance = rmRandInt(1,2);
   int lightingChance = rmRandInt(1,2);
   int socketPattern = rmRandInt(1,2);   
   int nativeSetup = rmRandInt(0,18);
   if (cNumberNonGaiaPlayers > 4)
   {
	if (nativeSetup == 9)
         nativeSetup = rmRandInt(11,18);
	if (nativeSetup == 10)
         nativeSetup = rmRandInt(0,8);
   }	 
   int nativePattern = -1;
   int nativeNumber = rmRandInt(2,6);
   int endPosition = rmRandInt(1,3);
   int sidePosition = rmRandInt(1,3);
   int sheepChance = rmRandInt(1,2);
   int cliffChance = rmRandInt(1,10);
   int makeCliffs = -1; 
   int cliffVariety = rmRandInt(1,5);
   int makeRiver = 1;
   int centerMt = -1;
   int forestMt = -1;
   int mtForest = -1;
   int vultures = -1;
   int eagles = -1;
   int plainsMap = -1;
   int hillTrees = -1;
   int placeBerries = 1;
   int extraBerries = 0;
   int baseHt = -1;
   int forestDist = rmRandInt(12,18);
   int circChance = rmRandInt(1,5);
   int placeCircular = 0;
   int axisChance = 1;
   int playerSide = rmRandInt(1,2);   
   int twoChoice = rmRandInt(1,2);
   int threeChoice = rmRandInt(1,3);
   int fourChoice = rmRandInt(1,4);
   int fiveChoice = rmRandInt(1,5);
   int placeGold = rmRandInt(1,5);
   int coverUp = 0;
   int specialPatch = 0;
   int noCliffForest = 0;

// Picks the map size
   int playerTiles = 20000;
   if (cNumberNonGaiaPlayers == 8)
	playerTiles = 14000;
   else if (cNumberNonGaiaPlayers == 7)
	playerTiles = 14500;
   else if (cNumberNonGaiaPlayers == 6)
	playerTiles = 15750;
   else if (cNumberNonGaiaPlayers == 5)
	playerTiles = 16500;
   else if (cNumberNonGaiaPlayers == 4)
	playerTiles = 17500;
   else if (cNumberNonGaiaPlayers == 3)
	playerTiles = 18500;

   int size=2*sqrt(cNumberNonGaiaPlayers*playerTiles);
   int longSide=1.6*size;  
   rmSetMapSize(longSide, size);
   
// Elevation
   int elevationChance = rmRandInt(1,4);
  // rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)

   if (elevationChance == 1)
   {
	rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);
	rmSetMapElevationHeightBlend(1.0);
   }
   else if (elevationChance == 2)
   {
	rmSetMapElevationParameters(cElevTurbulence, 0.02, 3, 0.5, 8.0);
	rmSetMapElevationHeightBlend(1.0);
   }  
   else if (elevationChance == 3)
   {
	rmSetMapElevationParameters(cElevTurbulence, 0.1, 5, 0.2, 5.0);
	rmSetMapElevationHeightBlend(0.9);
   }
   else if (elevationChance == 4)
   {
	rmSetMapElevationParameters(cElevTurbulence, 0.1, 4, 0.2, 3.0);
	rmSetMapElevationHeightBlend(0.8);
   }
   rmSetSeaLevel(0.0);
	
   // Text
   rmSetStatusText("",0.05);

// Pick terrain patterns and features 
/*  can use these in single player to select favorite features - 
    but restore map from the zip file for use in multiplayer 
    to ensure files are exactly the same  */ 

//  variantChance = 2;
//  lightingChance = 1;
//  patternChance = 3;

   if (patternChance == 1) // NE
   {   
      rmSetMapType("newEngland");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("paris");
	else
	   rmSetLightingSet("new england");
      baseHt = rmRandFloat(1,3);
      baseType = "newengland_grass";
	forestType = "new england forest";
	riverType = "Amazon River";
      cliffType = "New England Inland Grass";
	treeType = "TreeNewEngland";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "moose";         
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "moose";
         centerHerdType = "turkey";        
	}
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
	if (twoChoice == 1)
	   nativePattern = 1;
	else
	   nativePattern = 40;
      hillTrees = rmRandInt(0,1);
	if (cliffChance > 2)
         makeCliffs = 1;
	extraBerries = 2;
   }
   else if (patternChance == 2) // carolina
   {
      rmSetMapType("carolina");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("312b_washington");
	else
	   rmSetLightingSet("carolina");
      baseHt = 1;
      baseType = "carolina_grass";
	forestType = "carolina pine forest";
	riverType = "Amazon River";
      cliffType = "Carolina Inland";
	treeType = "TreeCarolinaGrass";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "deer";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "deer";
         centerHerdType = "turkey";        
	}   
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
	if (twoChoice == 1)
	   nativePattern = 1;
	else
	   nativePattern = 3;
      hillTrees = rmRandInt(0,1);
      makeCliffs = 2;
	extraBerries = 1;
   }
   else if (patternChance == 3) // bayou
   {
      rmSetMapType("bayou");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("berlin dusk");
	else
         rmSetLightingSet("bayou");
      baseHt = 1;
      baseType = "bayou_grass";
	forestType = "bayou swamp forest";
	riverType = "Amazon River";
	treeType = "TreeBayou";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "deer";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "deer";
         centerHerdType = "turkey";        
	}
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
	if (twoChoice == 1)
	   nativePattern = 3;
	else
	   nativePattern = 21;
	eagles = 1;
      makeCliffs = 0;
	extraBerries = 1;
   }
   else if (patternChance == 4) // great lakes
   {
      rmSetMapType("greatlakes");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("constantinople");
	else
         rmSetLightingSet("Great Lakes");
      baseHt = rmRandFloat(1,3);
      baseType = "greatlakes_grass";
	forestType = "great lakes forest";
	riverType = "Amazon River";
      cliffType = "New England Inland Grass";
	treeType = "TreeGreatLakes";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "moose";
         centerHerdType = "bison";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "moose";        
	}   
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
	if (fiveChoice == 1)
	   nativePattern = 4;
	else if (fiveChoice == 2)
	   nativePattern = 5;
	else if (fiveChoice == 3)
	   nativePattern = 40;
	else if (fiveChoice == 4)
	   nativePattern = 22;
	else
	   nativePattern = 41;
      hillTrees = rmRandInt(0,1);
      makeCliffs = 2;
	extraBerries = 2;
   }
   else if (patternChance == 5) // great lakes winter
   {
      rmSetMapType("greatlakes");
      rmSetMapType("snow");
	if (lightingChance == 1)
	   rmSetLightingSet("308b_caribbeanlight");
	else
         rmSetLightingSet("Great Lakes Winter");
      baseHt = 1;
      baseType = "greatlakes_snow";
	forestType = "great lakes forest snow";
	riverType = "Yukon River";
      cliffType = "rocky mountain2";
	treeType = "TreeGreatLakesSnow";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "moose";
         centerHerdType = "elk";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "bison";
         centerHerdType = "moose";       
	}      
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
      placeBerries = 0;
	if (fiveChoice == 1)
	   nativePattern = 4;
	else if (fiveChoice == 2)
	   nativePattern = 5;
	else if (fiveChoice == 3)
	   nativePattern = 40;
	else if (fiveChoice == 4)
	   nativePattern = 22;
	else
	   nativePattern = 41;
      hillTrees = rmRandInt(0,1);
      makeCliffs = 2;
   }
   else if (patternChance == 6) // yukon tundra
   {
      rmSetMapType("yukon");
      rmSetMapType("snow");
	if (lightingChance == 1)
         rmSetLightingSet("seville morning");
	else
         rmSetLightingSet("yukon");
      baseHt = 1;
      baseType = "yukon grass";
	forestType = "yukon forest";
	riverType = "Yukon River";
      cliffType = "rocky mountain2";
	treeType = "TreeYukon";
      variantChance = rmRandInt(1,3);
      if (variantChance == 1)
	{
         deerType = "muskOx";
         deer2Type = "caribou";
         centerHerdType = "caribou";
      }
	else if (variantChance == 2)
      {
         deerType = "muskOx";
         deer2Type = "caribou";
         centerHerdType = "bighornsheep";
	}
      else 
	{  
         deerType = "caribou"; 
         deer2Type = "muskOx";
         centerHerdType = "caribou";     
	}
      sheepChance = 0;
      placeBerries = 0;
	if (threeChoice == 1)
	   nativePattern = 5;
	else if (threeChoice == 2)
	   nativePattern = 6;
	else
	   nativePattern = 16; 
      hillTrees = 0; 
      makeCliffs = 0;
   }
   else if (patternChance == 7) // yukon
   {
      rmSetMapType("yukon");
      rmSetMapType("snow");
	if (lightingChance == 1)
	   rmSetLightingSet("305b");
	else
         rmSetLightingSet("yukon");
      baseHt = 1;
      baseType = "yukon snow";
	forestType = "yukon snow forest";
	riverType = "Yukon River";
      cliffType = "rocky mountain2";
	treeType = "TreeYukonSnow";
      if (variantChance == 1)
	{
         deerType = "caribou";
         deer2Type = "muskOx";
         centerHerdType = "bighornsheep";
	}
      else 
	{     
         deerType = "muskOx";
         deer2Type = "caribou";
         centerHerdType = "caribou";       
	}
      sheepChance = 0;
      placeBerries = 0;
	if (fiveChoice == 1)
	   nativePattern = 5;
	else if (fiveChoice == 2)
	   nativePattern = 6;
	else if (fiveChoice == 3)
	   nativePattern = 8;
	else if (fiveChoice == 4)
	   nativePattern = 16;
	else
	   nativePattern = 28;
      hillTrees = rmRandInt(0,1);
      makeCliffs = 2;
   }
   else if (patternChance == 8) // great plains 1
   {
      rmSetMapType("greatPlains");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("ottoman morning");
	else
         rmSetLightingSet("great plains");
       
      baseHt = 1;
      baseType = "great plains grass"; 
	forestType = "great plains forest";
	riverType = "Amazon River";
      cliffType = "Great Plains";
	treeType = "TreeGreatPlains";
      if (variantChance == 1)
	{
         deerType = "bison";
         deer2Type = "pronghorn";
         centerHerdType = "bison";
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "elk";
	} 
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
	if (fiveChoice == 1)
	   nativePattern = 23;
	else if (fiveChoice == 2)
	   nativePattern = 29;
	else if (fiveChoice == 3)
	   nativePattern = 19;
	else if (fiveChoice == 4)
	   nativePattern = 8;
	else
	   nativePattern = 2;
      vultures = 1;
      plainsMap = 1;
      makeCliffs = 2;
	extraBerries = 1;
   }
   else if (patternChance == 9) // texas grass
   {   
      rmSetMapType("texas");
	rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("pampas");
	else
         rmSetLightingSet("texas");
      baseHt = rmRandFloat(1,3);
      baseType = "texas_grass";
	forestType = "texas forest";
	riverType = "Amazon River";
      cliffType = "Texas Grass";
	treeType = "TreeTexas";
      if (variantChance == 1)
	{
         deerType = "bison";
         deer2Type = "deer";
         centerHerdType = "bison";
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "bison";
	}
      sheepType = "cow";
	if (fiveChoice == 1)
	   nativePattern = 19;
	else if (fiveChoice == 2)
	   nativePattern = 30;
	else if (fiveChoice == 3)
	   nativePattern = 29;
	else if (fiveChoice == 4)
	   nativePattern = 9;
	else
	   nativePattern = 2;
      vultures = 1;
      plainsMap = 1;
      makeCliffs = 2;
	extraBerries = 2;
   }
   else if (patternChance == 10) // texas desert
   {   
      rmSetMapType("texas");
	rmSetMapType("grass");
      if (lightingChance == 1)
         rmSetLightingSet("seville");
      else
         rmSetLightingSet("pampas");
      baseHt = rmRandFloat(1,3);
      baseType = "texas_dirt";
	forestType = "texas forest dirt";
	riverType = "Pampas River";
      cliffType = "Texas";
	treeType = "TreeTexasDirt";
      if (variantChance == 1)
	{
         deerType = "bison";
         deer2Type = "pronghorn";
         centerHerdType = "pronghorn";
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "bison";
	}
      sheepType = "cow";
	if (fiveChoice == 1)
	   nativePattern = 20;
	else if (fiveChoice == 2)
	   nativePattern = 32;
	else if (fiveChoice == 3)
	   nativePattern = 29;
	else if (fiveChoice == 4)
	   nativePattern = 30;
	else
	   nativePattern = 2;
      vultures = 1;
	if (cliffChance > 2)
         makeCliffs = 1;
   }
   else if (patternChance == 11) // sonora
   {   
      rmSetMapType("sonora");
	rmSetMapType("grass");
      rmSetLightingSet("pampas");
      baseHt = 1;
      baseType = "sonora_dirt";
	forestType = "sonora forest";
	riverType = "Pampas River";
      cliffType = "Sonora";
      cliffVariety = 6;
	treeType = "TreeSonora";
      if (variantChance == 1)
	{
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "bighornsheep";         
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bighornsheep";
         centerHerdType = "bison";         
	}
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
	if (fiveChoice == 1)
	   nativePattern = 10;
	else if (fiveChoice == 2)
	   nativePattern = 31;
	else if (fiveChoice == 3)
	   nativePattern = 32;
	else if (fiveChoice == 4)
	   nativePattern = 33;
	else
	   nativePattern = 37;
      vultures = 1;
      makeCliffs = 1;
   }
   else if (patternChance == 12) // yucatan
   {
      rmSetMapType("yucatan");
      rmSetMapType("tropical");
	if (lightingChance == 1)
	   rmSetLightingSet("311b");
	else
         rmSetLightingSet("yucatan");
     
      baseHt = 1;
      baseType = "yucatan_grass";
	forestType = "yucatan forest";
	riverType = "Amazon River";
      cliffType = "Amazon";
	treeType = "TreeYucatan";
      if (variantChance == 1)
      {
         deerType = "tapir";
         deer2Type = "capybara";
         centerHerdType = "turkey";
      }
      else
	{
         deerType = "capybara";
         deer2Type = "turkey";
         centerHerdType = "tapir";
	}
      sheepChance = 0;
	if (fiveChoice == 1)
	   nativePattern = 11;
	else if (fiveChoice == 2)
	   nativePattern = 12;
	else if (fiveChoice == 3)
	   nativePattern = 34;
	else if (fiveChoice == 4)
	   nativePattern = 35;
	else
	   nativePattern = 36;
      hillTrees = rmRandInt(0,1);
      cliffChance = 2;
	extraBerries = 1;
   }
   else if (patternChance == 13) // amazon
   {
      rmSetMapType("amazonia");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("323b_inca");
	else
         rmSetLightingSet("amazon");
      baseHt = 1;
      baseType = "amazon grass";
	forestType = "amazon rain forest";
	riverType = "Amazon River";
      cliffType = "Amazon";
	treeType = "TreeAmazon";
      if (variantChance == 1)
      {
         deerType = "tapir";
         deer2Type = "tapir";
         centerHerdType = "capybara";
      }
      else
	{
         deerType = "capybara";
         deer2Type = "tapir";
         centerHerdType = "capybara";
	}
      sheepChance = 0;
	if (fiveChoice == 1)
	   nativePattern = 13;
	else if (fiveChoice == 2)
	   nativePattern = 14;
	else if (fiveChoice == 3)
	   nativePattern = 15;
	else if (fiveChoice == 4)
	   nativePattern = 18;
	else
	   nativePattern = 26;
      cliffChance = 2;
	extraBerries = 1;
   }
   else if (patternChance == 14) // pampas
   {
      rmSetMapType("pampas");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("texas");
	else
         rmSetLightingSet("pampas");
      baseHt = 1;
	if (cliffVariety < 3)  // not used for cliffs!
	   baseType = "pampas_grass";
	else
         baseType = "pampas_dirt";
	forestType = "pampas forest";
	treeType = "TreePampas";
	riverType = "Pampas River";
      cliffType = "Sonora";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "rhea";
         centerHerdType = "rhea";
	}
      else 
	{     
         deerType = "rhea";
         deer2Type = "deer";
         centerHerdType = "rhea";
	}
      sheepType = "llama";
	if (threeChoice == 1)
	   nativePattern = 14;
	else if (threeChoice == 2)
	   nativePattern = 25;
	else
	   nativePattern = 26;
      vultures = 1;
      eagles = 1;
      makeCliffs = 0;
	extraBerries = 2;
   }
   else if (patternChance == 15) // patagonia
   {
      rmSetMapType("patagonia");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("paris day");
	else
         rmSetLightingSet("patagonia");
      baseHt = rmRandFloat(1,3);
      baseType = "patagonia_grass";
	forestType = "patagonia forest";
	riverType = "Amazon River";
      cliffType = "Patagonia";
	treeType = "TreePatagoniaDirt";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "rhea";
         centerHerdType = "rhea";
	}
      else 
	{     
         deerType = "rhea";
         deer2Type = "deer";
         centerHerdType = "rhea";
	}
      sheepType = "llama";
	if (fiveChoice == 1)
	   nativePattern = 14;
	else if (fiveChoice == 2)
	   nativePattern = 15;
	else if (fiveChoice == 3)
	   nativePattern = 17;
	else if (fiveChoice == 4)
	   nativePattern = 18;
	else
	   nativePattern = 24;
      hillTrees = rmRandInt(0,1);
      makeCliffs = 2;
	extraBerries =2;
   }
   else if (patternChance == 16) // andes
   {
      rmSetMapType("andes");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("sonora");
	else
         rmSetLightingSet("patagonia");
      baseHt = rmRandFloat(1,3);
	if (twoChoice == 1)
         baseType = "andes_grass_a";
	else
         baseType = "andes_grass_b";
	forestType = "andes forest";
	riverType = "Andes River";
      cliffType = "andes";
	treeType = "TreeAndes";
      if (variantChance == 1)
	{
         deerType = "guanaco";
         deer2Type = "guanaco";
         centerHerdType = "rhea";
	}
      else 
	{     
         deerType = "guanaco";
         deer2Type = "guanaco";
         centerHerdType = "guanaco";
	}
      sheepType = "llama";
	if (fiveChoice == 1)
	   nativePattern = 14;
	else if (fiveChoice == 2)
	   nativePattern = 25;
	else if (fiveChoice == 3)
	   nativePattern = 25;
	else if (fiveChoice == 4)
	   nativePattern = 26;
	else
	   nativePattern = 26;
      hillTrees = rmRandInt(0,1);
      makeCliffs = 2;
      eagles = 1;
	extraBerries = 2;
   }
   else if (patternChance == 17) // great plains 2
   {
      rmSetMapType("greatPlains");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("ottoman morning");
	else
         rmSetLightingSet("great plains");
      baseHt = 1;
      baseType = "great plains drygrass";
	forestType = "great plains forest";
	riverType = "Andes River";
      cliffType = "Great Plains";
	treeType = "TreeGreatPlains";
      if (variantChance == 1)
	{
         deerType = "bison";
         deer2Type = "bison";
         centerHerdType = "pronghorn"; 
	}
      else 
	{     
         deerType = "pronghorn";
         deer2Type = "bison";
         centerHerdType = "elk";
	} 
      sheepType = "cow";
	if (fiveChoice == 1)
	   nativePattern = 23;
	else if (fiveChoice == 2)
	   nativePattern = 30;
	else if (fiveChoice == 3)
	   nativePattern = 20;
	else if (fiveChoice == 4)
	   nativePattern = 8;
	else
	   nativePattern = 2;
      makeCliffs = 2;
	vultures = 1;
      plainsMap = 1;
	coverUp = 1;
	extraBerries = 2;
   }
   else if (patternChance == 18) // araucania green
   {
      rmSetMapType("araucania");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("Araucania Central");
	else
         rmSetLightingSet("great plains");
      baseHt = 1;
	if (twoChoice == 1)
	{
         baseType = "araucania_grass_a";
	   patchMixType = "araucania_grass_b";
	}
	else
	{
         baseType = "araucania_grass_b";
	   patchMixType = "araucania_grass_c";
	}
	forestType = "Araucania Forest";
	riverType = "Andes River";
	cliffType = "Araucania Central";      
	treeType = "TreeAraucania";
      if (variantChance == 1)
	{
         deerType = "guanaco";
         deer2Type = "deer";
         centerHerdType = "guanaco"; 
	}
      else 
	{     
         deerType = "guanaco";
         deer2Type = "guanaco";
         centerHerdType = "guanaco";
	} 
      sheepType = "llama";
	if (fiveChoice == 1)
	   nativePattern = 14;
	else if (fiveChoice == 2)
	   nativePattern = 25;
	else if (fiveChoice == 3)
	   nativePattern = 25;
	else if (fiveChoice == 4)
	   nativePattern = 26;
	else
	   nativePattern = 26;
      makeCliffs = 2;
	coverUp = 1;
	specialPatch = 1;
	extraBerries = 1;
   }
   else if (patternChance == 19) // california green
   {
      rmSetMapType("california");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("california");
	else
         rmSetLightingSet("Great Lakes");       
      baseHt = 1;
      baseType = "california_grass";
	if (twoChoice == 1)
	{
	   patchMixType = "california_grassrocks"; 
	}
	else
	{
	   patchMixType = "california_snowground5";  
	}
	if (threeChoice < 3)
	{ 
	   forestType = "california redwood forest";
	   treeType = "TreeRedwood";
	}
	else
	{
	   forestType = "California pine forest";
	   treeType = "TreePonderosaPine";
	}
	riverType = "Andes River";
      cliffType = "California";
      if (variantChance == 1)
	{
         deerType = "elk";
         deer2Type = "deer";
         centerHerdType = "elk";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "deer";
         centerHerdType = "elk";
	} 
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
	if (fiveChoice < 4)
	   nativePattern = 27;
	else
	   nativePattern = 28;
      makeCliffs = 2;
	specialPatch = 1;
	extraBerries = 1;
   }
   else if (patternChance == 20) // california rocky
   {
      rmSetMapType("california");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("california");
	else
         rmSetLightingSet("araucania");       
      baseHt = 1;
	if (twoChoice == 1)
	{
	   baseType = "california_snowground5";
	   patchMixType = "california_grassrocks"; 
	}
	else
	{
	   baseType = "california_grassrocks";
	   patchMixType = "california_snowground5";  
	}
 	if (threeChoice > 1)
	{
	   forestType = "california madrone forest";
	   treeType = "TreeMadrone";
	}
	else
	{
	   forestType = "California pine forest";
	   treeType = "TreePonderosaPine";
	}
	riverType = "Andes River";
      cliffType = "California";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "elk";
         centerHerdType = "deer";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "deer";
         centerHerdType = "elk";
	} 
      if (sheepChance == 1)
         sheepType = "cow";
      else
         sheepType = "sheep";
	if (fiveChoice < 4)
	   nativePattern = 27;
	else
	   nativePattern = 28;
      makeCliffs = 2;
	specialPatch = 1;
	extraBerries = 2;
   }
   else if (patternChance == 21) // nwt
   {
      rmSetMapType("northwestTerritory");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("nwterritory");
	else
         rmSetLightingSet("saguenay");
      baseHt = 1;
      baseType = "nwt_grass1";
	if (twoChoice == 1)
	{
	   forestType = "NW Territory Birch Forest";
   	   treeType = "TreeGreatLakes";
	}
	else
	{ 
	   forestType = "NW Territory Forest";
	   treeType = "TreeGreatPlains";   
	}
	riverType = "Northwest Territory Water";
      cliffType = "California";
      if (variantChance == 1)
	{
         deerType = "elk";
         deer2Type = "deer";
         centerHerdType = "moose"; 
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "moose";
         centerHerdType = "elk";
	} 
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "cow";
	if (fourChoice == 1)
	   nativePattern = 27;
	else if (fourChoice == 2)
	   nativePattern = 28;
	else if (fourChoice == 3)
	   nativePattern = 7;
	else
	   nativePattern = 6;
      makeCliffs = 0;
      eagles = 1;
	extraBerries = 2;
   }
   else if (patternChance == 22) // mexican palm desert
   {   
      rmSetMapType("sonora");
	rmSetMapType("grass");
      if (lightingChance == 1)
         rmSetLightingSet("seville");
      else
         rmSetLightingSet("pampas");
      baseHt = rmRandFloat(1,3);
      baseType = "texas_dirt";
	forestType = "caribbean palm forest";
	riverType = "Pampas River";
      cliffType = "Texas";
	treeType = "TreeCaribbean";
      if (variantChance == 1)
	{
         deerType = "deer";
         deer2Type = "turkey";
         centerHerdType = "deer";
	}
      else 
	{     
         deerType = "deer";
         deer2Type = "deer";
         centerHerdType = "turkey";
	}
      sheepType = "cow";
	if (fourChoice == 1)
	   nativePattern = 11;
	else if (fourChoice == 2)
	   nativePattern = 34;
	else if (fourChoice == 3)
	   nativePattern = 35;
	else 
	   nativePattern = 36;
      vultures = 1;
      makeCliffs = 0;
	coverUp = 1;
   }
   else if (patternChance == 23) // araucania south
   {
      rmSetMapType("araucania");
      rmSetMapType("snow");
	if (lightingChance == 1)
	   rmSetLightingSet("SthAraucaniaLight");
	else
         rmSetLightingSet("yukon");
      baseHt = 1;
	baseType = "araucania_snow_a";
	forestType = "Patagonia Snow Forest";
	riverType = "Yukon River";
      cliffType = "Araucania South";
	treeType = "TreePatagoniaSnow";
      if (variantChance == 1)
	{
         deerType = "guanaco";
         deer2Type = "guanaco";
         centerHerdType = "guanaco";
	}
      else 
	{     
         deerType = "guanaco";
         deer2Type = "guanaco";
         centerHerdType = "guanaco";       
	}
      if (sheepChance == 1)
         sheepType = "sheep";
      else
         sheepType = "llama";
      placeBerries = 0;
	if (fourChoice == 1)
	   nativePattern = 25;
	else if (fourChoice == 2)
	   nativePattern = 26;
	else if (fourChoice == 3)
	   nativePattern = 25;
	else
	   nativePattern = 26;
      hillTrees = rmRandInt(0,1);
      makeCliffs = 2;
	noCliffForest = 1;
   }
   else if (patternChance == 24) // saguenay
   {
      rmSetMapType("saguenay");
      rmSetMapType("grass");
	if (lightingChance == 1)
	   rmSetLightingSet("lisbon");
	else
         rmSetLightingSet("saguenay");
      baseHt = 1;
      baseType = "saguenay grass";
	forestType = "saguenay forest";
	riverType = "Hudson Bay";
      cliffType = "Andes";
	treeType = "TreeSaguenay";
      if (variantChance == 1)
	{
         deerType = "caribou";
         deer2Type = "moose";
         centerHerdType = "caribou";
	}
      else 
	{     
         deerType = "caribou";
         deer2Type = "caribou";
         centerHerdType = "moose";       
	}
      sheepChance = 0;
	if (threeChoice == 1)
	   nativePattern = 5;
	else if (threeChoice == 2)
	   nativePattern = 6;
	else if (threeChoice == 3)
	   nativePattern = 16;
      hillTrees = 0;
      makeCliffs = 0;
	extraBerries = 2;
   }

  if (nativePattern == 1)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Iroquois");
      native2Name = "native iroquois village ";
  }
  else if (nativePattern == 2)
  {
      rmSetSubCiv(0, "Comanche");
      native1Name = "native comanche village ";
      rmSetSubCiv(1, "Lakota");
      native2Name = "native lakota village ";
  }
  else if (nativePattern == 3)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Seminoles");
      native2Name = "native seminole village ";
  }
  else if (nativePattern == 4)
  {
      rmSetSubCiv(0, "Iroquois");
      native1Name = "native iroquois village ";
      rmSetSubCiv(1, "Lakota");
      native2Name = "native lakota village ";
  }
  else if (nativePattern == 5)
  {
      rmSetSubCiv(0, "Huron");
      native1Name = "native huron village ";
      rmSetSubCiv(1, "Cree");
      native2Name = "native cree village ";
  }
  else if (nativePattern == 6)
  {
      rmSetSubCiv(0, "Nootka");
      native1Name = "native nootka village ";
      rmSetSubCiv(1, "Cree");
      native2Name = "native cree village ";
  }
  else if (nativePattern == 7)
  {
      rmSetSubCiv(0, "Nootka");
      native1Name = "native nootka village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 8)
  {
      rmSetSubCiv(0, "Cree");
      native1Name = "native cree village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 9)
  {
      rmSetSubCiv(0, "Seminoles");
      native1Name = "native seminole village ";
      rmSetSubCiv(1, "Comanche");
      native2Name = "native comanche village ";
  }
  else if (nativePattern == 10)
  {
      rmSetSubCiv(0, "Zapotec");
      native1Name = "native zapotec village ";
      rmSetSubCiv(1, "Comanche");
      native2Name = "native comanche village ";
  }
  else if (nativePattern == 11)
  {
      rmSetSubCiv(0, "Aztecs");
      native1Name = "native aztec village ";
      rmSetSubCiv(1, "Maya");
      native2Name = "native maya village ";
  }
  else if (nativePattern == 12)
  {
      rmSetSubCiv(0, "Caribs");
      native1Name = "native carib village ";
      rmSetSubCiv(1, "Maya");
      native2Name = "native maya village ";
  }
  else if (nativePattern == 13)
  {
      rmSetSubCiv(0, "Caribs");
      native1Name = "native carib village ";
      rmSetSubCiv(1, "Tupi");
      native2Name = "native tupi village ";
  }
  else if (nativePattern == 14)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Tupi");
      native2Name = "native tupi village ";
  }
  else if (nativePattern == 15)
  {
      rmSetSubCiv(0, "Maya");
      native1Name = "native maya village ";
      rmSetSubCiv(1, "Tupi");
      native2Name = "native tupi village ";
  }
  else if (nativePattern == 16)
  {
      rmSetSubCiv(0, "Nootka");
      native1Name = "native nootka village ";
      rmSetSubCiv(1, "Huron");
      native2Name = "native huron village ";
  }
  else if (nativePattern == 17)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Aztecs");
      native2Name = "native aztec village ";
  }
  else if (nativePattern == 18)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Caribs");
      native2Name = "native carib village ";
  }
  else if (nativePattern == 19)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 20)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Comanche");
      native2Name = "native comanche village ";
  }
  else if (nativePattern == 21)
  {
      rmSetSubCiv(0, "Seminoles");
      native1Name = "native seminole village ";
      rmSetSubCiv(1, "Iroquois");
      native2Name = "native iroquois village ";
  }
  else if (nativePattern == 22)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Cree");
      native2Name = "native cree village ";
  }
  else if (nativePattern == 23)
  {
      rmSetSubCiv(0, "Comanche");
      native1Name = "native comanche village ";
      rmSetSubCiv(1, "Cree");
      native2Name = "native cree village ";
  }
  else if (nativePattern == 24)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Maya");
      native2Name = "native maya village ";
  }
  else if (nativePattern == 25)
  {
      rmSetSubCiv(0, "Incas");
      native1Name = "native inca village ";
      rmSetSubCiv(1, "Mapuche");
      native2Name = "native mapuche village ";
  }
  else if (nativePattern == 26)
  {
      rmSetSubCiv(0, "Tupi");
      native1Name = "native tupi village ";
      rmSetSubCiv(1, "Mapuche");
      native2Name = "native mapuche village ";
  }
  else if (nativePattern == 27)
  {
      rmSetSubCiv(0, "Klamath");
      native1Name = "native klamath village ";
      rmSetSubCiv(1, "Nootka");
      native2Name = "native nootka village ";
  }
  else if (nativePattern == 28)
  {
      rmSetSubCiv(0, "Klamath");
      native1Name = "native klamath village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 29)
  {
      rmSetSubCiv(0, "Comanche");
      native1Name = "native comanche village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 30)
  {
      rmSetSubCiv(0, "Apache");
      native1Name = "native apache village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 31)
  {
      rmSetSubCiv(0, "Apache");
      native1Name = "native apache village ";
      rmSetSubCiv(1, "Navajo");
      native2Name = "native navajo village ";
  }
  else if (nativePattern == 32)
  {
      rmSetSubCiv(0, "Apache");
      native1Name = "native apache village ";
      rmSetSubCiv(1, "Comanche");
      native2Name = "native comanche village ";
  }
  else if (nativePattern == 33)
  {
      rmSetSubCiv(0, "Apache");
      native1Name = "native apache village ";
      rmSetSubCiv(1, "Zapotec");
      native2Name = "native zapotec village ";
  }
  else if (nativePattern == 34)
  {
      rmSetSubCiv(0, "Aztecs");
      native1Name = "native aztec village ";
      rmSetSubCiv(1, "Zapotec");
      native2Name = "native zapotec village ";
  }
  else if (nativePattern == 35)
  {
      rmSetSubCiv(0, "Maya");
      native1Name = "native maya village ";
      rmSetSubCiv(1, "Zapotec");
      native2Name = "native zapotec village ";
  }
  else if (nativePattern == 36)
  {
      rmSetSubCiv(0, "Caribs");
      native1Name = "native carib village ";
      rmSetSubCiv(1, "Zapotec");
      native2Name = "native zapotec village ";
  }
  else if (nativePattern == 37)
  {
      rmSetSubCiv(0, "Navajo");
      native1Name = "native navajo village ";
      rmSetSubCiv(1, "Zapotec");
      native2Name = "native zapotec village ";
  }
  else if (nativePattern == 38)
  {
      rmSetSubCiv(0, "Navajo");
      native1Name = "native navajo village ";
      rmSetSubCiv(1, "Comanche");
      native2Name = "native comanche village ";
  }
  else if (nativePattern == 39)
  {
      rmSetSubCiv(0, "Navajo");
      native1Name = "native navajo village ";
      rmSetSubCiv(1, "Cheyenne");
      native2Name = "native cheyenne village ";
  }
  else if (nativePattern == 40)
  {
      rmSetSubCiv(0, "Cherokee");
      native1Name = "native cherokee village ";
      rmSetSubCiv(1, "Huron");
      native2Name = "native huron village ";
  }
  else if (nativePattern == 41)
  {
      rmSetSubCiv(0, "Lakota");
      native1Name = "native lakota village ";
      rmSetSubCiv(1, "Huron");
      native2Name = "native huron village ";
  }

   rmSetBaseTerrainMix(baseType);
   rmTerrainInitialize("yukon\ground1_yuk", 1);
   rmEnableLocalWater(false);
   rmSetMapType("land");

   rmSetWorldCircleConstraint(true);
   rmSetWindMagnitude(2.0);

// Precipitation
   if (patternChance == 13) // amazon
      if (lightingChance == 2)
         rmSetGlobalRain( 1.0 );
   if (patternChance == 7) // yukon
      if (lightingChance == 2)
         rmSetGlobalSnow( 0.8 );
   if (patternChance == 5) // great lakes winter
      rmSetGlobalSnow( 0.7 );
   if (patternChance == 12) // yucatan
      if (lightingChance == 2)
         rmSetGlobalRain( 0.7 );
   if (patternChance == 6) // yukon tundra
      if (lightingChance == 2)         
         rmSetGlobalSnow( 0.7 );
   if (patternChance == 21) // nwt
      if (lightingChance == 1)
         rmSetGlobalRain( 0.7 );
   
   chooseMercs();

// Define some classes.
   int classPlayer=rmDefineClass("player");
   rmDefineClass("classHill");
   rmDefineClass("classPatch");
   rmDefineClass("starting settlement");
   rmDefineClass("startingUnit");
   rmDefineClass("classForest");
   rmDefineClass("importantItem");
   rmDefineClass("natives");
   rmDefineClass("classMountain");
   rmDefineClass("center");
   rmDefineClass("classNugget");
   rmDefineClass("socketClass");
   rmDefineClass("classCliff");
   int canyon=rmDefineClass("canyon");
   int classHuntable=rmDefineClass("huntableFood");   
   int classHerdable=rmDefineClass("herdableFood"); 

   // Text
   rmSetStatusText("",0.10);

// -------------Define constraints
   // Map edge constraints
   int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(10), rmZTilesToFraction(10), 1.0-rmXTilesToFraction(10), 1.0-rmZTilesToFraction(10), 0.01);
   int secondEdgeConstraint=rmCreateBoxConstraint("avoid edge of map", rmXTilesToFraction(20), rmZTilesToFraction(20), 1.0-rmXTilesToFraction(20), 1.0-rmZTilesToFraction(20), 0.01);
   int circleConstraint=rmCreatePieConstraint("circle Constraint", 0.5, 0.5, 0, rmZFractionToMeters(0.485), rmDegreesToRadians(0), rmDegreesToRadians(360));
   int circleConstraintMt=rmCreatePieConstraint("circle Constraint for mts", 0.5, 0.5, 0, size*0.38, rmDegreesToRadians(0), rmDegreesToRadians(360));

   // Center constraints
   int centerConstraint=rmCreateClassDistanceConstraint("stay away from center", rmClassID("center"), 30.0);
   int centerConstraintShort=rmCreateClassDistanceConstraint("stay away from center short", rmClassID("center"), 12.0);
   int centerConstraintFar=rmCreateClassDistanceConstraint("stay away from center far", rmClassID("center"), 50.0);

   // Player constraints
   int playerConstraintForest=rmCreateClassDistanceConstraint("forests kinda stay away from players", classPlayer, 15.0);
   int playerConstraint=rmCreateClassDistanceConstraint("stay away from players", classPlayer, 40.0);
   int mediumPlayerConstraint=rmCreateClassDistanceConstraint("medium stay away from players", classPlayer, 25.0);
   int nuggetPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players a lot", classPlayer, 60.0);
   int farPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players more", classPlayer, 85.0);
   int fartherPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players the most", classPlayer, 105.0);
   int enormousPlayerConstraint=rmCreateClassDistanceConstraint("stay away from players for asymmetric starts", classPlayer, 130.0);
   int longPlayerConstraint=rmCreateClassDistanceConstraint("land stays away from players", classPlayer, 70.0); 

   // Nature avoidance
   int forestObjConstraint=rmCreateTypeDistanceConstraint("forest obj", "all", 6.0);
   int shortForestConstraint=rmCreateClassDistanceConstraint("patch vs. forest", rmClassID("classForest"), 15.0);
   int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), forestDist);
   int avoidResource=rmCreateTypeDistanceConstraint("resource avoid resource", "resource", 20.0);
   int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 10.0);
   int shortAvoidSilver=rmCreateTypeDistanceConstraint("short gold avoid gold", "Mine", 20.0);
   int coinAvoidCoin=rmCreateTypeDistanceConstraint("coin avoids coin", "gold", 35.0);
   int avoidStartResource=rmCreateTypeDistanceConstraint("start resource no overlap", "resource", 1.0);
   int avoidSheep=rmCreateClassDistanceConstraint("sheep avoids sheep etc", rmClassID("herdableFood"), 35.0);
   int huntableConstraint=rmCreateClassDistanceConstraint("huntable constraint", rmClassID("huntableFood"), 35.0);
   int longHuntableConstraint=rmCreateClassDistanceConstraint("long huntable constraint", rmClassID("huntableFood"), 55.0);
   int forestsAvoidBison=rmCreateClassDistanceConstraint("forest avoids bison", rmClassID("huntableFood"), 15.0);

   // Avoid impassable land, certain features
   int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 4.0);
   int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
   int longAvoidImpassableLand=rmCreateTerrainDistanceConstraint("long avoid impassable land", "Land", false, 18.0);
   int hillConstraint=rmCreateClassDistanceConstraint("hill vs. hill", rmClassID("classHill"), 15.0);
   int shortHillConstraint=rmCreateClassDistanceConstraint("patches vs. hill", rmClassID("classHill"), 5.0);
   int longHillConstraint=rmCreateClassDistanceConstraint("far from hill", rmClassID("classHill"), 35.0);
   int medHillConstraint=rmCreateClassDistanceConstraint("medium from hill", rmClassID("classHill"), 28.0);
   int patchConstraint=rmCreateClassDistanceConstraint("patch vs. patch", rmClassID("classPatch"), 8.0);
   int avoidCliffs=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 12.0);
   int cliffsAvoidCliffs=rmCreateClassDistanceConstraint("cliffs vs. cliffs", rmClassID("classCliff"), 30.0);
   int avoidWater10 = rmCreateTerrainDistanceConstraint("avoid water mid-long", "Land", false, 10.0);
   int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water mid-longer", "Land", false, 15.0);
   int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water a little more", "Land", false, 20.0);
   int avoidWater30 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 30.0);
   int avoidCanyons=rmCreateClassDistanceConstraint("avoid canyons", rmClassID("canyon"), 35.0);
   int shortAvoidCanyons=rmCreateClassDistanceConstraint("short avoid canyons", rmClassID("canyon"), 15.0);
  
   // Unit avoidance
   int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 30.0);
   int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 10.0);
   int avoidImportantItem=rmCreateClassDistanceConstraint("things avoid each other", rmClassID("importantItem"), 10.0);
   int avoidImportantItemSmall=rmCreateClassDistanceConstraint("important item small avoidance", rmClassID("importantItem"), 7.0);
   int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 60.0);
   int avoidNativesMed=rmCreateClassDistanceConstraint("stuff avoids natives medium", rmClassID("natives"), 35.0);
   int avoidNativesShort=rmCreateClassDistanceConstraint("stuff avoids natives shorter", rmClassID("natives"), 15.0);
   int avoidNugget=rmCreateClassDistanceConstraint("nugget vs. nugget", rmClassID("classNugget"), 42.0);
   int avoidNuggetMed=rmCreateClassDistanceConstraint("nugget vs. nugget med", rmClassID("classNugget"), 50.0);
   int avoidNuggetLong=rmCreateClassDistanceConstraint("nugget vs. nugget long", rmClassID("classNugget"), 70.0);
   int avoidNuggetSmall=rmCreateTypeDistanceConstraint("avoid nuggets by a little", "AbstractNugget", 10.0);
   int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);

   // Trade route avoidance.
   int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 8.0);
   int avoidTradeRouteCliff = rmCreateTradeRouteDistanceConstraint("trade route cliff", 10.0);
   int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 20.0);
   int avoidSocket=rmCreateClassDistanceConstraint("avoid sockets", rmClassID("socketClass"), 10.0);

// ---------------------------------------------------------------------------------------

   // Text
   rmSetStatusText("",0.15);

// Set up player starting locations
if (cNumberTeams == 2)
{
   if (cNumberNonGaiaPlayers == 2)
   {
	   rmSetPlacementTeam(0);
	   if (playerSide == 1)
	   {
            rmSetPlacementSection(0.22, 0.23);
	   }
	   else
	   {
            rmSetPlacementSection(0.77, 0.78);
	   }
	   rmPlacePlayersCircular(0.37, 0.38, 0.0);

	   rmSetPlacementTeam(1);
	   if (playerSide == 2)
	   {
            rmSetPlacementSection(0.27, 0.28);
	   }
	   else
	   {
            rmSetPlacementSection(0.72, 0.73);
	   }
	   rmPlacePlayersCircular(0.37, 0.38, 0.0);
   }
   else if (cNumberNonGaiaPlayers < 5)
   {
	   rmSetPlacementTeam(0);
	   if (playerSide == 1)
	   {
            rmSetPlacementSection(0.18, 0.32);
	   }
	   else
	   {
	      rmSetPlacementSection(0.68, 0.82);
	   }
	   rmPlacePlayersCircular(0.37, 0.38, 0.0);

	   rmSetPlacementTeam(1);
	   if (playerSide == 2)
	   {
            rmSetPlacementSection(0.18, 0.32);
	   }
	   else
	   {
	      rmSetPlacementSection(0.68, 0.82);
	   }
	   rmPlacePlayersCircular(0.37, 0.38, 0.0);
   }
   else if (cNumberNonGaiaPlayers < 7)
   {
	   rmSetPlacementTeam(0);
	   if (playerSide == 1)
	   {
            rmSetPlacementSection(0.14, 0.36);
	   }
	   else
	   {
	      rmSetPlacementSection(0.64, 0.86);
	   }
	   rmPlacePlayersCircular(0.38, 0.39, 0.0);

	   rmSetPlacementTeam(1);
	   if (playerSide == 2)
	   {
            rmSetPlacementSection(0.14, 0.36);
	   }
	   else
	   {
	      rmSetPlacementSection(0.64, 0.86);
	   }
	   rmPlacePlayersCircular(0.38, 0.39, 0.0);
   }
   else
   {
	   rmSetPlacementTeam(0);
	   if (playerSide == 1)
	   {
            rmSetPlacementSection(0.13, 0.37);
	   }
	   else
	   {
	      rmSetPlacementSection(0.63, 0.87);
	   }
	   rmPlacePlayersCircular(0.39, 0.4, 0.0);

	   rmSetPlacementTeam(1);
	   if (playerSide == 2)
	   {
            rmSetPlacementSection(0.13, 0.37);
	   }
	   else
	   {
	      rmSetPlacementSection(0.63, 0.87);
	   }
	   rmPlacePlayersCircular(0.39, 0.4, 0.0);
   }
}
else if (cNumberTeams > 2)
   rmPlacePlayersSquare(0.38, 0.0, 0.0);

   // Text
   rmSetStatusText("",0.20);
	
// Set up player areas.
   float playerFraction=rmAreaTilesToFraction(120);
   for(i=1; <cNumberPlayers)
   {
      int id=rmCreateArea("Player"+i);
      rmSetPlayerArea(i, id);
      rmSetAreaSize(id, playerFraction, playerFraction);
      rmAddAreaToClass(id, classPlayer);
      rmSetAreaMinBlobs(id, 1);
      rmSetAreaMaxBlobs(id, 1);
      rmAddAreaConstraint(id, playerConstraint); 
      rmAddAreaConstraint(id, longAvoidImpassableLand);
      rmAddAreaConstraint(id, playerEdgeConstraint); 
      rmAddAreaConstraint(id, avoidWater20); 
      rmSetAreaLocPlayer(id, i);
      rmSetAreaMix(id, baseType);
      rmSetAreaWarnFailure(id, false);
   }
   rmBuildAllAreas();

   // Text
   rmSetStatusText("",0.25);

// Rivers
      int riverWidthChance = rmRandInt(1,3);
      int rivermin = -1;
      int rivermax = -1;
      int shallowPattern = rmRandInt(1,6);

      if (riverWidthChance == 1)
      {
	   rivermin = 7;
	   rivermax = 9;
      }
      else if (riverWidthChance == 2)
      {
         rivermin = 8;
	   rivermax = 10;
      }
      else
      {
         rivermin = 9;
	   rivermax = 11;
      }

	int singleRiver = rmRiverCreate(-1, riverType, 30, 10, rivermin, rivermax); 
      rmRiverSetConnections(singleRiver, 0.35, 0.0, 0.35, 1.0);

	if (shallowPattern == 6) // single larger centered 
	{
	   rmRiverSetShallowRadius(singleRiver, rmRandInt(16, 22));
	   rmRiverAddShallow(singleRiver, rmRandFloat(0.31, 0.33));
	}
	else
	{
	 if (shallowPattern < 3) // .4 and .6 crossings for 1 and 2
	 {	
	   rmRiverSetShallowRadius(singleRiver, rmRandInt(7, 11));
	   rmRiverAddShallow(singleRiver, rmRandFloat(0.21, 0.23)); 

	   rmRiverSetShallowRadius(singleRiver, rmRandInt(7, 11));
	   rmRiverAddShallow(singleRiver, rmRandFloat(0.42, 0.44));
	 }
	 if (shallowPattern < 4) // end crossings, for 2-3
	 {
	   if (shallowPattern >1)
	   {	
	      rmRiverSetShallowRadius(singleRiver, rmRandInt(7, 11));
	      rmRiverAddShallow(singleRiver, rmRandFloat(0.05, 0.06)); 

	      rmRiverSetShallowRadius(singleRiver, rmRandInt(7, 11));
	      rmRiverAddShallow(singleRiver, rmRandFloat(0.58, 0.59));
	   }
	 }
	 if (shallowPattern > 3) // end crossings for 4, 5
	 {	
	   rmRiverSetShallowRadius(singleRiver, rmRandInt(8, 13));
	   rmRiverAddShallow(singleRiver, rmRandFloat(0.08, 0.12)); 

	   rmRiverSetShallowRadius(singleRiver, rmRandInt(8, 13));
	   rmRiverAddShallow(singleRiver, rmRandFloat(0.53, 0.56));
	 }
	 if (shallowPattern > 2) // center for patterns 3, 4
	 {
	   if (shallowPattern < 5)
	   {	
	      rmRiverSetShallowRadius(singleRiver, rmRandInt(7, 11));
	      rmRiverAddShallow(singleRiver, rmRandFloat(0.31, 0.33));
	   }
	 }
	}
	rmRiverSetBankNoiseParams(singleRiver, 0.07, 2, 1.5, 10.0, 0.667, 3.0); 
	rmRiverBuild(singleRiver);

	shallowPattern = rmRandInt(1,6);

	int secondRiver = rmRiverCreate(-1, riverType, 30, 10, rivermin, rivermax); 
      rmRiverSetConnections(secondRiver, 0.65, 0.0, 0.65, 1.0);

	if (shallowPattern == 6) // single larger centered 
	{
	   rmRiverSetShallowRadius(secondRiver, rmRandInt(16, 22));
	   rmRiverAddShallow(secondRiver, rmRandFloat(0.31, 0.33));
	}
	else
	{
	 if (shallowPattern < 3) // .4 and .6 crossings for 1 and 2
	 {	
	   rmRiverSetShallowRadius(secondRiver, rmRandInt(7, 11));
	   rmRiverAddShallow(secondRiver, rmRandFloat(0.21, 0.23)); 

	   rmRiverSetShallowRadius(secondRiver, rmRandInt(7, 11));
	   rmRiverAddShallow(secondRiver, rmRandFloat(0.42, 0.44));
	 }
	 if (shallowPattern < 4) // end crossings, for 2-3
	 {
	   if (shallowPattern >1)
	   {	
	      rmRiverSetShallowRadius(secondRiver, rmRandInt(7, 11));
	      rmRiverAddShallow(secondRiver, rmRandFloat(0.05, 0.06)); 

	      rmRiverSetShallowRadius(secondRiver, rmRandInt(7, 11));
	      rmRiverAddShallow(secondRiver, rmRandFloat(0.57, 0.59));
	   }
	 }
	 if (shallowPattern > 3) // end crossings for 4, 5
	 {	
	   rmRiverSetShallowRadius(secondRiver, rmRandInt(8, 13));
	   rmRiverAddShallow(secondRiver, rmRandFloat(0.08, 0.12)); 

	   rmRiverSetShallowRadius(secondRiver, rmRandInt(8, 13));
	   rmRiverAddShallow(secondRiver, rmRandFloat(0.53, 0.56));
	 }
	 if (shallowPattern > 2) // center for patterns 3, 4
	 {
	   if (shallowPattern < 5)
	   {	
	      rmRiverSetShallowRadius(secondRiver, rmRandInt(7, 11));
	      rmRiverAddShallow(secondRiver, rmRandFloat(0.31, 0.33));
	   }
	 }
	}
	rmRiverSetBankNoiseParams(secondRiver, 0.07, 2, 1.5, 10.0, 0.667, 3.0); 
	rmRiverBuild(secondRiver);


   // Text
   rmSetStatusText("",0.30);


// Trade Routes
variantChance = rmRandInt(1,2);

  // center route 
   int tradeRouteID6 = rmCreateTradeRoute();
   rmAddTradeRouteWaypoint(tradeRouteID6, 0.5, 0.0);
   rmAddTradeRouteWaypoint(tradeRouteID6, 0.48, 0.17);
   rmAddTradeRouteWaypoint(tradeRouteID6, 0.48, 0.2);
   rmAddTradeRouteWaypoint(tradeRouteID6, 0.52, 0.35);
   rmAddTradeRouteWaypoint(tradeRouteID6, 0.5, 0.48);
   rmAddTradeRouteWaypoint(tradeRouteID6, 0.5, 0.52);
   rmAddTradeRouteWaypoint(tradeRouteID6, 0.48, 0.65);
   rmAddTradeRouteWaypoint(tradeRouteID6, 0.52, 0.8);
   rmAddTradeRouteWaypoint(tradeRouteID6, 0.52, 0.83);
   rmAddTradeRouteWaypoint(tradeRouteID6, 0.5, 1.0);
   rmBuildTradeRoute(tradeRouteID6, "carolinas\trade_route");	

// Edge Trade Routes
   // west route
   int tradeRouteID7 = rmCreateTradeRoute();
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.15, 0.0);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.12, 0.11);	
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.09, 0.25);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.08, 0.35);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.06, 0.4);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.055, 0.47);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.055, 0.53);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.06, 0.6);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.08, 0.65);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.09, 0.75);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.12, 0.89);
   rmAddTradeRouteWaypoint(tradeRouteID7, 0.15, 1.0);
   rmBuildTradeRoute(tradeRouteID7, "dirt");

   // east route
   int tradeRouteID7A = rmCreateTradeRoute();
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.85, 0.0);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.88, 0.11);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.91, 0.25);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.92, 0.35);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.94, 0.4);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.945, 0.47);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.945, 0.53);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.94, 0.6);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.92, 0.65);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.91, 0.75);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.88, 0.89);
   rmAddTradeRouteWaypoint(tradeRouteID7A, 0.85, 1.0);
   rmBuildTradeRoute(tradeRouteID7A, "carolinas\trade_route");	

   // Text
   rmSetStatusText("",0.35);

// Trade sockets
   int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
   rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
   rmSetObjectDefAllowOverlap(socketID, true);
   rmAddObjectDefToClass(socketID, rmClassID("importantItem"));
   rmSetObjectDefMinDistance(socketID, 0.0);
   rmSetObjectDefMaxDistance(socketID, 7.0);
   variantChance = rmRandInt(1,2);

   // center route
   if (socketPattern == 1)  // 4 or 6 sockets 
   {
	if (cNumberNonGaiaPlayers > 4)
	{
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID6);
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.09);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.25);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.41);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.59);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.75);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.91);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	else
      {
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID6);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.12);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.35);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.65);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.88);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
   }
   else if (socketPattern == 2)  // 3 or 5 sockets 
   {
	if (cNumberNonGaiaPlayers > 3)
	{
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID6);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.12);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.31);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.69);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.88);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	else
      {
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID6);
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.18);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID6, 0.82);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
   }

   twoChoice = rmRandInt(1,2);
   int socketNum = 1;
   if (cNumberNonGaiaPlayers > 4)
	socketNum = 2;
   if (cNumberNonGaiaPlayers == 4)
   {
	if (twoChoice == 2)
   	   socketNum = 2;
   }

   // edge routes
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID7);
   if (socketNum == 1) // 1 per route
   { 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
   else // 2 per route
   { 
	if (socketPattern == 1)
	{
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7, 0.35);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7, 0.65);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	else
	{
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7, 0.25);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7, 0.75);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
   }

   // change the trade route for the new sockets
   rmSetObjectDefTradeRouteID(socketID, tradeRouteID7A);
   if (socketNum == 1) // 1 per route
   { 
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7A, 0.5);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
   }
   else // 2 per route
   { 
	if (socketPattern == 1)
	{
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7A, 0.35);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7A, 0.65);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
	else
	{
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7A, 0.25);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);

      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID7A, 0.75);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	}
   }

   //Text
   rmSetStatusText("",0.40);

// Starting TCs and units 	
   int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
   rmSetObjectDefMinDistance(startingUnits, 5.0);
   rmSetObjectDefMaxDistance(startingUnits, 10.0);
   rmAddObjectDefConstraint(startingUnits, avoidAll);
   rmAddObjectDefConstraint(startingUnits, avoidWater10);

   int startingTCID= rmCreateObjectDef("startingTC");
   rmSetObjectDefMaxDistance(startingTCID, 18.0);
   rmAddObjectDefConstraint(startingTCID, avoidAll);
   rmAddObjectDefConstraint(startingTCID, avoidWater20);
   rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);
   rmAddObjectDefConstraint(startingTCID, longAvoidImpassableLand );                
   if ( rmGetNomadStart())
   {
	rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
   }
   else
   {
      rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
   }

   for(i=1; <cNumberPlayers)
   {	
      rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }

// Central features & patches, per map or variant
   // Center area
   int centerArea=rmCreateArea("TheCenter");
   rmSetAreaSize(centerArea, 0.25, 0.25);
   rmSetAreaLocation(centerArea, 0.5, 0.5);
   rmSetAreaCoherence(centerArea, 0.9);
   rmAddAreaInfluenceSegment(centerArea, 0.5, 0.0, 0.5, 1.0);
   rmAddAreaToClass(centerArea, rmClassID("center")); 
   rmBuildArea(centerArea);

// Dirt patches for Sonora
   if (patternChance == 11)
   {
	for (i=0; <cNumberNonGaiaPlayers*5)   
      {
		int dirtPatch=rmCreateArea("open dirt patch "+i);
		rmSetAreaWarnFailure(dirtPatch, false);
		rmSetAreaSize(dirtPatch, rmAreaTilesToFraction(150), rmAreaTilesToFraction(200));
		rmSetAreaTerrainType(dirtPatch, "sonora\ground7_son");
		rmAddAreaToClass(dirtPatch, rmClassID("classPatch"));
		rmSetAreaMinBlobs(dirtPatch, 1);
		rmSetAreaMaxBlobs(dirtPatch, 5);
		rmSetAreaMinBlobDistance(dirtPatch, 16.0);
		rmSetAreaMaxBlobDistance(dirtPatch, 40.0);
		rmSetAreaCoherence(dirtPatch, 0.0);
		rmSetAreaSmoothDistance(dirtPatch, 10);
		rmAddAreaConstraint(dirtPatch, shortAvoidImpassableLand);
		rmAddAreaConstraint(dirtPatch, patchConstraint);
		rmBuildArea(dirtPatch); 
      }
   }

   // Text
   rmSetStatusText("",0.45);

// NATIVES
   // Village A 
   int villageAID = -1;
   int whichNative = rmRandInt(1,2);
   int villageType = rmRandInt(1,5);

   if (whichNative == 1)
	   villageAID = rmCreateGrouping("village A", native1Name+villageType);
   else if (whichNative == 2)
	   villageAID = rmCreateGrouping("village A", native2Name+villageType);

   rmAddGroupingToClass(villageAID, rmClassID("natives"));
   rmAddGroupingToClass(villageAID, rmClassID("importantItem"));
   rmSetGroupingMinDistance(villageAID, 0.0);
   rmSetGroupingMaxDistance(villageAID, size*0.1);
   rmAddGroupingConstraint(villageAID, avoidImpassableLand);
   rmAddGroupingConstraint(villageAID, avoidTradeRoute);
   rmAddGroupingConstraint(villageAID, avoidWater10);
   rmAddGroupingConstraint(villageAID, avoidNativesMed);
   rmAddGroupingConstraint(villageAID, playerConstraint);

   // Village D - opposite type from A 
   int villageDID = -1;
   villageType = rmRandInt(1,5);

   if (whichNative == 2)
	   villageDID = rmCreateGrouping("village D", native1Name+villageType);
   else if (whichNative == 1)
	   villageDID = rmCreateGrouping("village D", native2Name+villageType);

   rmAddGroupingToClass(villageDID, rmClassID("natives"));
   rmAddGroupingToClass(villageDID, rmClassID("importantItem"));
   rmSetGroupingMinDistance(villageDID, 0.0);
   rmSetGroupingMaxDistance(villageDID, size*0.06);
   rmAddGroupingConstraint(villageDID, avoidImpassableLand);
   rmAddGroupingConstraint(villageDID, avoidTradeRoute);
   rmAddGroupingConstraint(villageDID, avoidWater10);
   rmAddGroupingConstraint(villageDID, avoidNativesMed);
   rmAddGroupingConstraint(villageDID, playerConstraint);

   // Village B - randomly same or opposite village A
   int villageBID = -1;	
   villageType = rmRandInt(1,5);
   whichNative = rmRandInt(1,2);

   if (whichNative == 1)
	   villageBID = rmCreateGrouping("village B", native1Name+villageType);
   else if (whichNative == 2)
	   villageBID = rmCreateGrouping("village B", native2Name+villageType);

   rmAddGroupingToClass(villageBID, rmClassID("importantItem"));
   rmAddGroupingToClass(villageBID, rmClassID("natives"));
   rmSetGroupingMinDistance(villageBID, 0.0);
   rmSetGroupingMaxDistance(villageBID, size*0.1);
   rmAddGroupingConstraint(villageBID, avoidImpassableLand);
   rmAddGroupingConstraint(villageBID, avoidTradeRoute);
   rmAddGroupingConstraint(villageBID, avoidWater15);
   rmAddGroupingConstraint(villageBID, avoidNatives);
   rmAddGroupingConstraint(villageBID, playerConstraint);

   // Village C // appears in center, variable, randomly same or opposite A and B
   int villageCID = -1;	
   villageType = rmRandInt(1,5);
   whichNative = rmRandInt(1,2);

   if (whichNative == 1)
	   villageCID = rmCreateGrouping("village C", native1Name+villageType);
   else if (whichNative == 2)
	   villageCID = rmCreateGrouping("village C", native2Name+villageType);

   rmAddGroupingToClass(villageCID, rmClassID("importantItem"));
   rmAddGroupingToClass(villageCID, rmClassID("natives"));
   rmSetGroupingMinDistance(villageCID, 0.0);
   rmSetGroupingMaxDistance(villageCID, size*0.08);
   rmAddGroupingConstraint(villageCID, avoidImpassableLand);
   rmAddGroupingConstraint(villageCID, avoidWater10);
   rmAddGroupingConstraint(villageCID, avoidTradeRoute);
   rmAddGroupingConstraint(villageCID, avoidNatives);
   rmAddGroupingConstraint(villageCID, playerConstraint);

// Placement of Natives
   if ((nativeSetup == 13) || (nativeSetup == 17))    
   {
      if (axisChance == 2)
	{
  	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageAID, 0, 0.79, 0.36);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.21, 0.36);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.79, 0.64);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.21, 0.64);
		   if (nativeSetup == 17)
		   {	
			rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.4);
			rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.6);
		   }
  	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageAID, 0, 0.68, 0.4);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.32, 0.4);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.68, 0.6);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.32, 0.6);
		   if (nativeSetup == 17)
		   {	
			rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.34);
			rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.66);
		   }
	      }
      }
	else if (axisChance == 1)
	{
	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageAID, 0, 0.41, 0.79);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.41, 0.21);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.59, 0.79);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.59, 0.21);
		   if (nativeSetup == 17)
		   {	
			rmPlaceGroupingAtLoc(villageDID, 0, 0.31, 0.5);
			rmPlaceGroupingAtLoc(villageDID, 0, 0.69, 0.5);
		   }
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageAID, 0, 0.4, 0.7);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.4, 0.3);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.6, 0.7);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.6, 0.3);
		   if (nativeSetup == 17)
		   {	
			rmPlaceGroupingAtLoc(villageDID, 0, 0.4, 0.5);
			rmPlaceGroupingAtLoc(villageDID, 0, 0.6, 0.5);
		   }
	      }	   
	}
   }
   else if (nativeSetup == 18)    
   {
      if (axisChance == 2)
	{
               rmPlaceGroupingAtLoc(villageAID, 0, 0.74, 0.28);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.26, 0.28);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.74, 0.72);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.26, 0.72);
		   rmPlaceGroupingAtLoc(villageBID, 0, 0.5, 0.4);
		   rmPlaceGroupingAtLoc(villageBID, 0, 0.5, 0.6);
      }
	else if (axisChance == 1)
	{
               rmPlaceGroupingAtLoc(villageAID, 0, 0.28, 0.74);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.28, 0.26);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.72, 0.74);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.72, 0.26);
		   rmPlaceGroupingAtLoc(villageBID, 0, 0.4, 0.5);
		   rmPlaceGroupingAtLoc(villageBID, 0, 0.6, 0.5);
	}
   } 
   else if (nativeSetup == 14)
   {
      if (axisChance == 2)
	{
  	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageAID, 0, 0.79, 0.38);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.21, 0.38);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.79, 0.62);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.21, 0.62);
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageAID, 0, 0.67, 0.4);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.33, 0.4);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.67, 0.6);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.33, 0.6);
	      }
      }
	else if (axisChance == 1)
	{
	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageDID, 0, 0.4, 0.79);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.4, 0.21);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.6, 0.79);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.6, 0.21);
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageDID, 0, 0.4, 0.7);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.4, 0.3);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.6, 0.7);
		   rmPlaceGroupingAtLoc(villageDID, 0, 0.6, 0.3);
	      }
	}
   } 
   else if (nativeSetup > 14) // 15 AND 16
   {
	if (nativeSetup == 15)
	{
	   if (axisChance == 1)
	   {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.4, 0.51);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.6, 0.49);

         }
   	   else
	   {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.51, 0.6);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.49, 0.4);
	   }
	}
	rmAddGroupingConstraint(villageAID, avoidWater20);
	rmAddGroupingConstraint(villageDID, avoidWater20);
      if (axisChance == 2)
	{
  	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageAID, 0, 0.85, 0.135);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.15, 0.135);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.15, 0.865);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.85, 0.865);
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageAID, 0, 0.85, 0.135);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.15, 0.135);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.15, 0.865);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.85, 0.865);
	      }
      }
	else if (axisChance == 1)
	{
	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageDID, 0, 0.135, 0.85);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.135, 0.15);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.865, 0.15);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.865, 0.85);
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageAID, 0, 0.135, 0.85);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.135, 0.15);
               rmPlaceGroupingAtLoc(villageAID, 0, 0.865, 0.15);
		   rmPlaceGroupingAtLoc(villageAID, 0, 0.865, 0.85);
	      }
	}
   } 
   else if (nativeSetup < 4)
   {
      if (axisChance == 1)
	{
	   if (endPosition == 1)
            rmPlaceGroupingAtLoc(villageAID, 0, 0.505, 0.73);
	   else if (endPosition == 2)
            rmPlaceGroupingAtLoc(villageAID, 0, 0.495, 0.82);
	   else
            rmPlaceGroupingAtLoc(villageAID, 0, 0.505, 0.9);
	}	 
      else
	{
	   if (endPosition == 1)
            rmPlaceGroupingAtLoc(villageAID, 0, 0.73, 0.505);
	   else if (endPosition == 2)
            rmPlaceGroupingAtLoc(villageAID, 0, 0.82, 0.495);
	   else
            rmPlaceGroupingAtLoc(villageAID, 0, 0.9, 0.505);
	}
         
      if (axisChance == 1)
	{
	   if (endPosition == 1)
            rmPlaceGroupingAtLoc(villageBID, 0, 0.495, 0.27);
	   else if (endPosition == 2)
            rmPlaceGroupingAtLoc(villageBID, 0, 0.505, 0.18);
	   else
            rmPlaceGroupingAtLoc(villageBID, 0, 0.495, 0.10);
	}
      else
	{
	   if (endPosition == 1)
            rmPlaceGroupingAtLoc(villageBID, 0, 0.27, 0.495);
	   else if (endPosition == 2)
            rmPlaceGroupingAtLoc(villageBID, 0, 0.18, 0.505);
	   else
            rmPlaceGroupingAtLoc(villageBID, 0, 0.10, 0.495);
	}
	if (nativeSetup < 2)
	{
         if (nativeNumber > 2)
            rmPlaceGroupingAtLoc(villageCID, 0, 0.5, 0.5);
	}
	else 
	{
	   rmSetGroupingMaxDistance(villageCID, size*0.1);
         if (nativeNumber > 2)
	   {
		if (axisChance == 1)
		{
               rmPlaceGroupingAtLoc(villageCID, 0, 0.465, 0.5);
               rmPlaceGroupingAtLoc(villageCID, 0, 0.535, 0.5);
	      }
		else
		{
               rmPlaceGroupingAtLoc(villageCID, 0, 0.5, 0.535);
               rmPlaceGroupingAtLoc(villageCID, 0, 0.5, 0.465);
	      }
	   }
	}
   }
   else if (nativeSetup > 5)
   {
	if (nativeSetup == 6)
	{
         if (axisChance == 1)
	   {
		   if (threeChoice == 1)
		   {	
			rmPlaceGroupingAtLoc(villageBID, 0, 0.4, 0.5);
			rmPlaceGroupingAtLoc(villageBID, 0, 0.6, 0.5);
		   }
		   else if (threeChoice == 2)
		   {	
			rmPlaceGroupingAtLoc(villageBID, 0, 0.4, 0.35);
			rmPlaceGroupingAtLoc(villageBID, 0, 0.6, 0.65);
		   }
		   else if (threeChoice == 3)
		   {	
			rmPlaceGroupingAtLoc(villageBID, 0, 0.6, 0.35);
			rmPlaceGroupingAtLoc(villageBID, 0, 0.4, 0.65);
		   }
	   }
	   else if (axisChance == 2)
	   {
		   if (threeChoice == 1)
		   {	
			rmPlaceGroupingAtLoc(villageBID, 0, 0.5, 0.6);
			rmPlaceGroupingAtLoc(villageBID, 0, 0.5, 0.4);
		   }
		   else if (threeChoice == 2)
		   {	
			rmPlaceGroupingAtLoc(villageBID, 0, 0.35, 0.4);
			rmPlaceGroupingAtLoc(villageBID, 0, 0.65, 0.6);
		   }
		   else if (threeChoice == 3)
		   {	
			rmPlaceGroupingAtLoc(villageBID, 0, 0.65, 0.4);
			rmPlaceGroupingAtLoc(villageBID, 0, 0.35, 0.6);
		   }
	   }

	}
	if (nativeSetup == 7)
	{
         if (axisChance == 1)
	   {
	      if (endPosition == 1)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.495, 0.75); 
	      else if (endPosition == 2)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.505, 0.84);  
	      else
               rmPlaceGroupingAtLoc(villageDID, 0, 0.495, 0.93); 
	   }
         else
	   {
	      if (endPosition == 1)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.75, 0.495);
	      else if (endPosition == 2)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.84, 0.505);
	      else
               rmPlaceGroupingAtLoc(villageDID, 0, 0.93, 0.495);
	   }
            
         if (axisChance == 1)
	   {
	      if (endPosition == 1)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.505, 0.25);
	      else if (endPosition == 2)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.495, 0.16);
	      else
               rmPlaceGroupingAtLoc(villageDID, 0, 0.505, 0.08);
	   }            
         else
	   {
	      if (endPosition == 1)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.25, 0.505);
	      else if (endPosition == 2)
               rmPlaceGroupingAtLoc(villageDID, 0, 0.16, 0.495);
	      else
               rmPlaceGroupingAtLoc(villageDID, 0, 0.08, 0.505);
	   }          
	}
	if (nativeSetup == 8)
	{
   	      rmSetGroupingMaxDistance(villageDID, size*0.1);
		if (axisChance == 1)
		{
               rmPlaceGroupingAtLoc(villageDID, 0, 0.465, 0.49);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.535, 0.51);
	      }
		else
		{
               rmPlaceGroupingAtLoc(villageDID, 0, 0.49, 0.535);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.51, 0.465);
	      }
	}
	if (nativeSetup == 11)
	{
		if (axisChance == 1)
		{
               rmPlaceGroupingAtLoc(villageBID, 0, 0.4, 0.5);
               rmPlaceGroupingAtLoc(villageBID, 0, 0.6, 0.5);
	      }
		else
		{
               rmPlaceGroupingAtLoc(villageBID, 0, 0.5, 0.4);
               rmPlaceGroupingAtLoc(villageBID, 0, 0.5, 0.6);
	      }
	}
	if (nativeSetup == 12)
	{
         if (axisChance == 2)
   	   {
  	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageDID, 0, 0.79, 0.38);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.21, 0.38);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.79, 0.62);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.21, 0.62);
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageDID, 0, 0.67, 0.4);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.33, 0.4);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.67, 0.6);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.33, 0.6);
	      }
         }
	   else if (axisChance == 1)
	   {
	      if (variantChance == 1)
	      {  
               rmPlaceGroupingAtLoc(villageDID, 0, 0.4, 0.79);
		   rmPlaceGroupingAtLoc(villageDID, 0, 0.4, 0.21);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.6, 0.79);
		   rmPlaceGroupingAtLoc(villageDID, 0, 0.6, 0.21);
	      }
	      else
	      {
               rmPlaceGroupingAtLoc(villageDID, 0, 0.31, 0.68);
		   rmPlaceGroupingAtLoc(villageDID, 0, 0.31, 0.32);
               rmPlaceGroupingAtLoc(villageDID, 0, 0.69, 0.68);
		   rmPlaceGroupingAtLoc(villageDID, 0, 0.69, 0.32);
	      }
	   }
	}
	if ((nativeSetup == 9) || (nativeSetup == 10) || (nativeSetup == 6))
	{
	   if (rmRandInt(1,2) == 1)
            rmPlaceGroupingInArea(villageCID, 0, rmAreaID("center"), 2);
	}
      for(i=1; <cNumberPlayers) 
      {
         rmSetGroupingMinDistance(villageAID, 65.0);
         rmSetGroupingMaxDistance(villageAID, 90.0);           
	   rmPlaceGroupingAtLoc(villageAID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	   if (nativeSetup == 9)
	   {
            rmSetGroupingMinDistance(villageDID, 65.0);
            rmSetGroupingMaxDistance(villageDID, 90.0);      
		rmPlaceGroupingAtLoc(villageDID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	   }
	   if (nativeSetup == 10)
		rmPlaceGroupingAtLoc(villageAID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      }
   }
   else if (nativeSetup > 3) // setup 4 and 5
   {
      if (axisChance == 1)
	{
	   if (endPosition == 1)
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.52, 0.75);
		rmPlaceGroupingAtLoc(villageAID, 0, 0.48, 0.25);
	   }
	   else if (endPosition == 2)
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.48, 0.84);
            rmPlaceGroupingAtLoc(villageAID, 0, 0.52, 0.16);
	   }
	   else
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.52, 0.91);
		rmPlaceGroupingAtLoc(villageAID, 0, 0.48, 0.09);
	   }
	}          
      else
	{
	   if (endPosition == 1)
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.75, 0.52);
	      rmPlaceGroupingAtLoc(villageAID, 0, 0.25, 0.48);
	   }
	   else if (endPosition == 2)
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.84, 0.52);
		rmPlaceGroupingAtLoc(villageAID, 0, 0.16, 0.48);
	   }
	   else
	   {
            rmPlaceGroupingAtLoc(villageAID, 0, 0.91, 0.48);
		rmPlaceGroupingAtLoc(villageAID, 0, 0.09, 0.52);
	   }
	}       
         
	if (nativeSetup == 4)
	{
	   if (axisChance == 1)
	   {

            rmPlaceGroupingAtLoc(villageDID, 0, 0.415, 0.5);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.585, 0.5);
         }
   	   else
	   {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.51, 0.585);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.49, 0.415);
	   }
	}
	if (nativeSetup == 5)
	{	
   	   rmSetGroupingMaxDistance(villageDID, size*0.1);
         if (axisChance == 1)
	   {
            if (sidePosition == 1)
	      {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.7, 0.5);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.3, 0.5);
	      }
	      else if (sidePosition == 2)
	      {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.74, 0.5);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.26, 0.5);
	      }
	      else
	      {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.78, 0.5);
            rmPlaceGroupingAtLoc(villageDID, 0, 0.22, 0.5);
		}
         }
	   else
	   {
            if (endPosition == 1)
	      {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.7);
		rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.3);
	      }	   
	      else if (endPosition == 2)
	      {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.74);
		rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.26);
	      }
	      else
	      {
            rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.78);
		rmPlaceGroupingAtLoc(villageDID, 0, 0.5, 0.22); 
            }
         }
	   if (rmRandInt(1,2) == 1) // extra possible natives near center
	   {
            rmPlaceGroupingAtLoc(villageCID, 0, 0.55, 0.5);
	      rmPlaceGroupingAtLoc(villageCID, 0, 0.45, 0.5); 
	   }
	}  
   }

   // Text
   rmSetStatusText("",0.50);

// Player Nuggets
   int playerNuggetID=rmCreateObjectDef("player nugget");
   rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
   rmAddObjectDefToClass(playerNuggetID, rmClassID("classNugget"));
   rmSetObjectDefMinDistance(playerNuggetID, 35.0);
   rmSetObjectDefMaxDistance(playerNuggetID, 45.0);
   rmAddObjectDefConstraint(playerNuggetID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
   rmAddObjectDefConstraint(playerNuggetID, avoidSocket);
   rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
   rmAddObjectDefConstraint(playerNuggetID, avoidWater10);
   for(i=1; <cNumberPlayers)
   {
 	rmSetNuggetDifficulty(1, 1);
	rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
   }

// Cliffs
   int cliffHt = -1;
   int failCount=0;
   int numTries=cNumberNonGaiaPlayers*14;
   int anotherChance = rmRandInt(0,1);

   if (makeCliffs == 2)
   {
     if (anotherChance == 1)
        makeCliffs = 1;
     else
        makeCliffs = 0;
   } 

   if (makeCliffs == 1)
   { 
	if (patternChance == 11) // for Sonora only
	{
	   // bigger mesas
	   for(i=0; <numTries)
	   {
		int mesaID=rmCreateArea("mesa"+i);
		rmSetAreaSize(mesaID, rmAreaTilesToFraction(25), rmAreaTilesToFraction(160)); 
		rmSetAreaWarnFailure(mesaID, false);
		rmSetAreaCliffType(mesaID, "Sonora");
		rmAddAreaToClass(mesaID, rmClassID("canyon"));
		rmAddAreaToClass(mesaID, rmClassID("classCliff"));	
		rmSetAreaCliffEdge(mesaID, 1, 1.0, 0.1, 1.0, 0);
	      rmSetAreaCliffHeight(mesaID, rmRandInt(5,9), 1.0, 1.0);
		rmAddAreaConstraint(mesaID, avoidCanyons);
		rmSetAreaMinBlobs(mesaID, 3);
		rmSetAreaMaxBlobs(mesaID, 5);
		rmSetAreaMinBlobDistance(mesaID, 3.0);
		rmSetAreaMaxBlobDistance(mesaID, 5.0);
		rmSetAreaCoherence(mesaID, 0.5);
		rmAddAreaConstraint(mesaID, playerConstraint); 
		rmAddAreaConstraint(mesaID, avoidSocket);
		rmAddAreaConstraint(mesaID, avoidNativesShort);
		rmAddAreaConstraint(mesaID, avoidWater20);
		rmAddAreaConstraint(mesaID, avoidTradeRoute);
		rmAddAreaConstraint(mesaID, shortAvoidSilver);
		if(rmBuildArea(mesaID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==2)
				break;
		}
		else
			failCount=0;
	   }
	// smaller mesas

	   numTries=cNumberNonGaiaPlayers*14;

	   for(i=0; <numTries)
	   {
		int smallCliffHeight=rmRandInt(0,10);
		int smallMesaID=rmCreateArea("small mesa"+i);
		rmSetAreaSize(smallMesaID, rmAreaTilesToFraction(4), rmAreaTilesToFraction(8));  
		rmSetAreaWarnFailure(smallMesaID, false);
		rmSetAreaCliffType(smallMesaID, "Sonora");
		rmAddAreaToClass(smallMesaID, rmClassID("canyon"));
		rmAddAreaToClass(smallMesaID, rmClassID("classCliff"));	
		rmSetAreaCliffEdge(smallMesaID, 1, 1.0, 0.1, 1.0, 0);
		rmSetAreaCliffHeight(smallMesaID, rmRandInt(5,8), 1.0, 1.0);
		rmAddAreaConstraint(smallMesaID, shortAvoidCanyons);
		rmSetAreaMinBlobs(smallMesaID, 3);
		rmSetAreaMaxBlobs(smallMesaID, 5);
		rmSetAreaMinBlobDistance(smallMesaID, 3.0);
		rmSetAreaMaxBlobDistance(smallMesaID, 5.0);
		rmSetAreaCoherence(smallMesaID, 0.3);
		rmAddAreaConstraint(smallMesaID, mediumPlayerConstraint); 
		rmAddAreaConstraint(smallMesaID, avoidNativesShort); 
		rmAddAreaConstraint(smallMesaID, avoidSocket);
		rmAddAreaConstraint(smallMesaID, avoidWater10);
		rmAddAreaConstraint(smallMesaID, avoidTradeRoute);
		rmAddAreaConstraint(smallMesaID, shortAvoidSilver);
		if(rmBuildArea(smallMesaID)==false)
		{
			// Stop trying once we fail 3 times in a row.
			failCount++;
			if(failCount==20)
				break;
		}
		else
			failCount=0;
	   }
	}
      else // all other maps with cliffs
      {
         int numCliffs = cNumberNonGaiaPlayers + rmRandInt(3,4);
	   if (cliffVariety == 2)
		   numCliffs = cNumberNonGaiaPlayers + rmRandInt(4,7);

         for (i=0; <numCliffs)
         {
		cliffHt = rmRandInt(5,7);    
		int bigCliffID=rmCreateArea("big cliff" +i);
		rmSetAreaWarnFailure(bigCliffID, false);
		rmSetAreaCliffType(bigCliffID, cliffType);
		rmAddAreaToClass(bigCliffID, rmClassID("classCliff"));
		if (cliffVariety == 1) // like Patagonia
		{
   	         rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(550), rmAreaTilesToFraction(750));
      	   rmSetAreaCliffEdge(bigCliffID, 2, 0.37, 0.1, 1.0, 0);
      	   rmSetAreaCliffPainting(bigCliffID, false, true, true, 1.5, true);
		   rmSetAreaCliffHeight(bigCliffID, 7, 2.0, 0.5);
		   rmSetAreaCoherence(bigCliffID, 0.5);
		   rmSetAreaSmoothDistance(bigCliffID, 5);
		   rmSetAreaHeightBlend(bigCliffID, 1.0);
		}
		else if (cliffVariety == 2) // smaller, kinda like in Sudden Death from AOM
		{
   	         rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(280), rmAreaTilesToFraction(400));
		   rmSetAreaCliffEdge(bigCliffID, 1, 0.65, 0.1, 1.0, 0);
		   rmSetAreaCliffPainting(bigCliffID, true, true, true, 1.5, true);
		   rmSetAreaCliffHeight(bigCliffID, cliffHt, 1.0, 1.0);
		   rmSetAreaCoherence(bigCliffID, rmRandFloat(0.4, 0.9));
		   rmSetAreaSmoothDistance(bigCliffID, 10);
		   rmSetAreaHeightBlend(bigCliffID, 2.0);
		}
		else  // kinda random, kinda like Texas or NE
		{
   	         rmSetAreaSize(bigCliffID, rmAreaTilesToFraction(400), rmAreaTilesToFraction(700));
		   rmSetAreaCliffEdge(bigCliffID, 1, 0.6, 0.1, 1.0, 0);
		   rmSetAreaCliffPainting(bigCliffID, true, true, true, 1.5, true);
		   rmSetAreaCliffHeight(bigCliffID, cliffHt, 2.0, 1.0);
		   rmSetAreaCoherence(bigCliffID, rmRandFloat(0.4, 0.9));
		   rmSetAreaSmoothDistance(bigCliffID, 15);
		   rmSetAreaHeightBlend(bigCliffID, 1.0);
		}
		rmSetAreaMinBlobs(bigCliffID, 3);
		rmSetAreaMaxBlobs(bigCliffID, 5);
		rmSetAreaMinBlobDistance(bigCliffID, 5.0);
		rmSetAreaMaxBlobDistance(bigCliffID, 18.0);
		rmAddAreaConstraint(bigCliffID, avoidImportantItem);
		rmAddAreaConstraint(bigCliffID, avoidTradeRoute);
            rmAddAreaConstraint(bigCliffID, avoidNatives);
	      rmAddAreaConstraint(bigCliffID, avoidWater20);
	      rmAddAreaConstraint(bigCliffID, cliffsAvoidCliffs);
	      rmAddAreaConstraint(bigCliffID, avoidSocket);
	      rmAddAreaConstraint(bigCliffID, avoidStartingUnits);
	      rmAddAreaConstraint(bigCliffID, longPlayerConstraint);
		rmBuildArea(bigCliffID);
         }
      }
   }

   // Text
   rmSetStatusText("",0.55);

// Random Nuggets
   int nugget2= rmCreateObjectDef("nugget medium"); 
   rmAddObjectDefItem(nugget2, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(2, 2);
   rmAddObjectDefToClass(nugget2, rmClassID("classNugget"));
   rmSetObjectDefMinDistance(nugget2, 60.0);
   rmSetObjectDefMaxDistance(nugget2, 110.0);
   rmAddObjectDefConstraint(nugget2, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(nugget2, avoidSocket);
   rmAddObjectDefConstraint(nugget2, avoidTradeRoute);
   rmAddObjectDefConstraint(nugget2, nuggetPlayerConstraint);
   rmAddObjectDefConstraint(nugget2, avoidNuggetMed);
   rmAddObjectDefConstraint(nugget2, playerEdgeConstraint);
   rmAddObjectDefConstraint(nugget2, avoidWater10);
   rmAddObjectDefConstraint(nugget2, avoidAll);
   rmPlaceObjectDefPerPlayer(nugget2, false, 1);

   int nugget3= rmCreateObjectDef("nugget hard"); 
   rmAddObjectDefItem(nugget3, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(3, 3);
   rmAddObjectDefToClass(nugget3, rmClassID("classNugget"));
   rmSetObjectDefMinDistance(nugget3, 80.0);
   rmSetObjectDefMaxDistance(nugget3, rmXFractionToMeters(0.6));
   rmAddObjectDefConstraint(nugget3, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(nugget3, avoidSocket);
   rmAddObjectDefConstraint(nugget3, avoidTradeRoute);
   rmAddObjectDefConstraint(nugget3, farPlayerConstraint);
   rmAddObjectDefConstraint(nugget3, avoidNuggetLong);
   rmAddObjectDefConstraint(nugget3, playerEdgeConstraint);
   rmAddObjectDefConstraint(nugget3, avoidWater10);
   rmAddObjectDefConstraint(nugget3, avoidAll);
   rmPlaceObjectDefPerPlayer(nugget3, false, 1);

   int nugget4= rmCreateObjectDef("nugget nuts"); 
   rmAddObjectDefItem(nugget4, "Nugget", 1, 0.0);
   rmSetNuggetDifficulty(4, 4);
   rmAddObjectDefToClass(nugget4, rmClassID("classNugget"));
   rmSetObjectDefMinDistance(nugget4, 0.0);
   rmSetObjectDefMaxDistance(nugget4, 4.0);
   rmAddObjectDefConstraint(nugget4, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(nugget4, avoidSocket);
   rmAddObjectDefConstraint(nugget4, avoidTradeRoute);
   rmAddObjectDefConstraint(nugget4, fartherPlayerConstraint);
   rmAddObjectDefConstraint(nugget4, avoidNuggetLong);
   rmAddObjectDefConstraint(nugget4, playerEdgeConstraint);
   rmAddObjectDefConstraint(nugget4, avoidWater10);
   rmAddObjectDefConstraint(nugget4, avoidAll);
   rmPlaceObjectDefInArea(nugget4, 0, rmAreaID("TheCenter"), cNumberNonGaiaPlayers); 

   rmAddObjectDefConstraint(nugget3, fartherPlayerConstraint);
   rmSetNuggetDifficulty(2, 3);
   rmPlaceObjectDefPerPlayer(nugget3, false, 1);

   // Text
   rmSetStatusText("",0.60);

// more resources
   // start area trees 
   int StartAreaTreeID=rmCreateObjectDef("starting trees");
   rmAddObjectDefItem(StartAreaTreeID, treeType, 1, 0.0);
   rmSetObjectDefMinDistance(StartAreaTreeID, 8);
   rmSetObjectDefMaxDistance(StartAreaTreeID, 12);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidTradeRoute);
   rmAddObjectDefConstraint(StartAreaTreeID, avoidAll);
   rmPlaceObjectDefPerPlayer(StartAreaTreeID, false, 3);

   // berry bushes
   int berryNum = rmRandInt(2,5);
   int StartBerryBushID=rmCreateObjectDef("starting berry bush");
   rmAddObjectDefItem(StartBerryBushID, "BerryBush", rmRandInt(2,4), 4.0);
   rmSetObjectDefMinDistance(StartBerryBushID, 10.0);
   rmSetObjectDefMaxDistance(StartBerryBushID, 16.0);
   rmAddObjectDefConstraint(StartBerryBushID, avoidStartingUnitsSmall);
   if (placeBerries == 1)
      rmPlaceObjectDefPerPlayer(StartBerryBushID, false, 1);
   if (extraBerries == 1)
      rmPlaceObjectDefInArea(StartBerryBushID, 0, rmAreaID("TheCenter"), cNumberNonGaiaPlayers);
   if (extraBerries == 2)
   {
	if (rmRandInt(1,2) == 1)
         rmPlaceObjectDefInArea(StartBerryBushID, 0, rmAreaID("TheCenter"), cNumberNonGaiaPlayers);
   }  

   // Text
   rmSetStatusText("",0.65);

   // start area huntable
   int deerNum = rmRandInt(5, 8);
   int startPronghornID=rmCreateObjectDef("starting pronghorn");
   rmAddObjectDefItem(startPronghornID, deerType, deerNum, 5.0);
   rmAddObjectDefToClass(startPronghornID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(startPronghornID, 16);
   rmSetObjectDefMaxDistance(startPronghornID, 22);
   rmAddObjectDefConstraint(startPronghornID, avoidStartResource);
   rmAddObjectDefConstraint(startPronghornID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(startPronghornID, avoidAll);
   rmSetObjectDefCreateHerd(startPronghornID, true);
   rmPlaceObjectDefPerPlayer(startPronghornID, false, 1);

   // second huntable
   int deer2Num = rmRandInt(4, 8);
   int farPronghornID=rmCreateObjectDef("far pronghorn");
   rmAddObjectDefItem(farPronghornID, deer2Type, deer2Num, 5.0);
   rmAddObjectDefToClass(farPronghornID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(farPronghornID, 42.0);
   rmSetObjectDefMaxDistance(farPronghornID, 60.0);
   rmAddObjectDefConstraint(farPronghornID, avoidStartResource);
   rmAddObjectDefConstraint(farPronghornID, mediumPlayerConstraint);
   rmAddObjectDefConstraint(farPronghornID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(farPronghornID, avoidNativesShort);
   rmAddObjectDefConstraint(farPronghornID, huntableConstraint);
   rmAddObjectDefConstraint(farPronghornID, avoidAll);
   rmSetObjectDefCreateHerd(farPronghornID, true);
   if (sheepChance == 0)
      rmPlaceObjectDefPerPlayer(farPronghornID, false, 2);
   else
      rmPlaceObjectDefPerPlayer(farPronghornID, false, 1);

   // additional second huntable for low player numbers
   if (cNumberNonGaiaPlayers < 4)
   {
      rmAddObjectDefConstraint(farPronghornID, fartherPlayerConstraint);
      rmSetObjectDefMinDistance(farPronghornID, rmXFractionToMeters(0.25));
      rmSetObjectDefMaxDistance(farPronghornID, rmXFractionToMeters(0.38));
      rmPlaceObjectDefPerPlayer(farPronghornID, false, 1);
   }

// Silver mines - players
   int silverType = -1;
   silverType = rmRandInt(1,10);
   int playerGoldID=rmCreateObjectDef("player silver closer");
   rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
   rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(playerGoldID, avoidSocket);
   rmAddObjectDefConstraint(playerGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(playerGoldID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(playerGoldID, avoidAll);
   rmAddObjectDefConstraint(playerGoldID, avoidWater10);
   rmSetObjectDefMinDistance(playerGoldID, 18.0);
   rmSetObjectDefMaxDistance(playerGoldID, 23.0);
   rmPlaceObjectDefPerPlayer(playerGoldID, false, 1);

   rmAddObjectDefConstraint(playerGoldID, playerConstraint);
   rmSetObjectDefMinDistance(playerGoldID, 50.0);
   rmSetObjectDefMaxDistance(playerGoldID, 60.0);
   rmPlaceObjectDefPerPlayer(playerGoldID, false, 1);

   silverType = rmRandInt(1,10);
   int GoldMediumID=rmCreateObjectDef("player silver med");
   rmAddObjectDefItem(GoldMediumID, "mine", 1, 0.0);
   rmAddObjectDefConstraint(GoldMediumID, avoidTradeRoute);
   rmAddObjectDefConstraint(GoldMediumID, avoidSocket);
   rmAddObjectDefConstraint(GoldMediumID, coinAvoidCoin);
   rmAddObjectDefConstraint(GoldMediumID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(GoldMediumID, farPlayerConstraint);
   rmAddObjectDefConstraint(GoldMediumID, avoidAll);
   rmAddObjectDefConstraint(GoldMediumID, avoidWater10);
   rmSetObjectDefMinDistance(GoldMediumID, 85.0);
   rmSetObjectDefMaxDistance(GoldMediumID, 100.0);
   rmPlaceObjectDefPerPlayer(GoldMediumID, false, 1);

   // Text
   rmSetStatusText("",0.70);

// Extra tree clumps near players - to ensure fair access to wood
   int extraTreesID=rmCreateObjectDef("extra trees");
   rmAddObjectDefItem(extraTreesID, treeType, 4, 5.0);
   rmSetObjectDefMinDistance(extraTreesID, 14);
   rmSetObjectDefMaxDistance(extraTreesID, 18);
   rmAddObjectDefConstraint(extraTreesID, avoidAll);
   rmAddObjectDefConstraint(extraTreesID, avoidCoin);
   rmAddObjectDefConstraint(extraTreesID, avoidSocket);
   rmAddObjectDefConstraint(extraTreesID, avoidTradeRoute);
   for(i=1; <cNumberPlayers)
      rmPlaceObjectDefInArea(extraTreesID, 0, rmAreaID("player"+i), 1);

   int extraTrees2ID=rmCreateObjectDef("more extra trees");
   rmAddObjectDefItem(extraTrees2ID, treeType, 5, 6.0);
   rmSetObjectDefMinDistance(extraTrees2ID, 18);
   rmSetObjectDefMaxDistance(extraTrees2ID, 28);
   rmAddObjectDefConstraint(extraTrees2ID, avoidAll);
   rmAddObjectDefConstraint(extraTrees2ID, avoidCoin);
   rmAddObjectDefConstraint(extraTrees2ID, avoidSocket);
   rmAddObjectDefConstraint(extraTrees2ID, avoidTradeRoute);
   for(i=1; <cNumberPlayers)
      rmPlaceObjectDefInArea(extraTrees2ID, 0, rmAreaID("player"+i), 2);

// Extra silver mines - more central.
   silverType = rmRandInt(1,10);
   int extraGoldID = rmCreateObjectDef("extra silver "+i);
   if (placeGold == 5)	
      rmAddObjectDefItem(extraGoldID, "minegold", 1, 0);
   else
      rmAddObjectDefItem(extraGoldID, "mine", 1, 0.0);
   rmAddObjectDefToClass(extraGoldID, rmClassID("importantItem"));
   rmAddObjectDefConstraint(extraGoldID, avoidTradeRoute);
   rmAddObjectDefConstraint(extraGoldID, avoidSocket);
   rmAddObjectDefConstraint(extraGoldID, coinAvoidCoin);
   rmAddObjectDefConstraint(extraGoldID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(extraGoldID, avoidWater10);
   rmAddObjectDefConstraint(extraGoldID, avoidAll);
   rmSetObjectDefMinDistance(extraGoldID, 0.0);
   rmSetObjectDefMaxDistance(extraGoldID, 80.0);
   rmPlaceObjectDefInArea(extraGoldID, 0, rmAreaID("TheCenter"), rmRandInt(4,5)); 
   if (cNumberNonGaiaPlayers > 4)
	rmPlaceObjectDefInArea(extraGoldID, 0, rmAreaID("TheCenter"), 2);     

   silverType = rmRandInt(1,10);
   int GoldFarID=rmCreateObjectDef("player silver far");
   if (placeGold == 1)
      rmAddObjectDefItem(GoldFarID, "minegold", 1, 0);
   else
      rmAddObjectDefItem(GoldFarID, "mine", 1, 0.0);
   rmAddObjectDefConstraint(GoldFarID, avoidTradeRoute);
   rmAddObjectDefConstraint(GoldFarID, avoidSocket);
   rmAddObjectDefConstraint(GoldFarID, coinAvoidCoin);
   rmAddObjectDefConstraint(GoldFarID, avoidImportantItemSmall);
   rmAddObjectDefConstraint(GoldFarID, avoidAll);
   rmAddObjectDefConstraint(GoldFarID, fartherPlayerConstraint);
   rmAddObjectDefConstraint(GoldFarID, centerConstraintFar);
   rmAddObjectDefConstraint(GoldFarID, avoidWater10);
   rmSetObjectDefMinDistance(GoldFarID, 125.0);
   rmSetObjectDefMaxDistance(GoldFarID, 170.0);
   rmPlaceObjectDefPerPlayer(GoldFarID, false, 1);

   // Text
   rmSetStatusText("",0.75);

// Main forests
   int forestChance = -1;
   int numFor=19*cNumberNonGaiaPlayers;
   if (cNumberNonGaiaPlayers > 3)
      numFor=17*cNumberNonGaiaPlayers;  
   if (cNumberNonGaiaPlayers > 5)
      numFor=14*cNumberNonGaiaPlayers;  
   if (cNumberNonGaiaPlayers > 7)
      numFor=12*cNumberNonGaiaPlayers;    

   failCount=0;
   for (i=0; <numFor)
   {
      forestChance = rmRandInt(1,4);
      int forest=rmCreateArea("forest "+i);
      rmSetAreaWarnFailure(forest, false);
      rmSetAreaSize(forest, rmAreaTilesToFraction(120), rmAreaTilesToFraction(240));
      rmSetAreaForestType(forest, forestType);
      rmSetAreaForestDensity(forest, rmRandFloat(0.7, 1.0));
      rmSetAreaForestClumpiness(forest, rmRandFloat(0.5, 0.9));
      rmSetAreaForestUnderbrush(forest, rmRandFloat(0.0, 0.5));
      rmSetAreaCoherence(forest, rmRandFloat(0.4, 0.7));
      rmSetAreaSmoothDistance(forest, rmRandInt(10,20));
      if (forestChance == 3)
      {
		rmSetAreaMinBlobs(forest, 1);
		rmSetAreaMaxBlobs(forest, 3);					
		rmSetAreaMinBlobDistance(forest, 12.0);
		rmSetAreaMaxBlobDistance(forest, 24.0);
	}
      if (forestChance == 4)
      {
		rmSetAreaMinBlobs(forest, 3);
		rmSetAreaMaxBlobs(forest, 5);					
		rmSetAreaMinBlobDistance(forest, 16.0);
		rmSetAreaMaxBlobDistance(forest, 28.0);
		rmSetAreaSmoothDistance(forest, 120);
	}
      rmAddAreaToClass(forest, rmClassID("classForest")); 
	rmAddAreaConstraint(forest, mediumPlayerConstraint);
      rmAddAreaConstraint(forest, forestConstraint);
      rmAddAreaConstraint(forest, avoidAll); 
	rmAddAreaConstraint(forest, avoidCoin);  
      rmAddAreaConstraint(forest, avoidImpassableLand); 
      rmAddAreaConstraint(forest, avoidTradeRoute);
	rmAddAreaConstraint(forest, avoidStartingUnits);
	rmAddAreaConstraint(forest, avoidSocket);
	rmAddAreaConstraint(forest, avoidNativesShort);
	rmAddAreaConstraint(forest, shortAvoidCanyons);
	if (noCliffForest == 1)
	   rmAddAreaConstraint(forest, avoidCliffs);
      if(rmBuildArea(forest)==false)
      {
         // Stop trying once we fail 3 times in a row.
         failCount++;
         if(failCount==5)
            break;
      }
      else
         failCount=0; 
   } 

   // Text
   rmSetStatusText("",0.80);

// sheep etc
   if (sheepChance > 0)
   {
      int sheepID=rmCreateObjectDef("herdable animal");
      rmAddObjectDefItem(sheepID, sheepType, 2, 4.0);
      rmAddObjectDefToClass(sheepID, rmClassID("herdableFood"));
      rmSetObjectDefMinDistance(sheepID, 40.0);
      rmSetObjectDefMaxDistance(sheepID, 0.25*longSide);
      rmAddObjectDefConstraint(sheepID, avoidSheep);
      rmAddObjectDefConstraint(sheepID, avoidAll);
      rmAddObjectDefConstraint(sheepID, playerConstraint);
      rmAddObjectDefConstraint(sheepID, avoidImpassableLand);
      rmPlaceObjectDefPerPlayer(sheepID, false, 2);
      rmAddObjectDefConstraint(sheepID, avoidCliffs);
      rmAddObjectDefConstraint(sheepID, farPlayerConstraint);
      rmSetObjectDefMinDistance(sheepID, 0.0);
      rmSetObjectDefMaxDistance(sheepID, 0.05*size);
      rmPlaceObjectDefInArea(sheepID, 0, rmAreaID("TheCenter"), cNumberNonGaiaPlayers*2); 
   }

   // Text
   rmSetStatusText("",0.85);

// Central herds
   int centralHerdID=rmCreateObjectDef("central herd");  
   rmAddObjectDefItem(centralHerdID, centerHerdType, rmRandInt(7,9), 6.0);
   rmAddObjectDefToClass(centralHerdID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(centralHerdID, 0.0);
   rmSetObjectDefMaxDistance(centralHerdID, 0.05*size);
   rmAddObjectDefConstraint(centralHerdID, avoidTradeRoute);
   rmAddObjectDefConstraint(centralHerdID, avoidImportantItem);
   rmAddObjectDefConstraint(centralHerdID, avoidWater10);
   rmAddObjectDefConstraint(centralHerdID, farPlayerConstraint);
   rmAddObjectDefConstraint(centralHerdID, longHuntableConstraint);
   rmSetObjectDefCreateHerd(centralHerdID, true);
   rmPlaceObjectDefInArea(centralHerdID, 0, rmAreaID("TheCenter"), rmRandInt(2,3)); 

   // additional of central herd type
   rmAddObjectDefConstraint(centralHerdID, fartherPlayerConstraint);
   rmSetObjectDefMinDistance(centralHerdID, 0.15*size);
   rmSetObjectDefMaxDistance(centralHerdID, 0.35*size);
   rmPlaceObjectDefAtLoc(centralHerdID, 0, 0.5, 0.5, 0.5*cNumberNonGaiaPlayers);

// far huntable
   int farHuntableID=rmCreateObjectDef("far huntable");
   rmAddObjectDefItem(farHuntableID, deerType, rmRandInt(5,9), 6.0);
   rmAddObjectDefToClass(farHuntableID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(farHuntableID, 0.2*size);
   rmSetObjectDefMaxDistance(farHuntableID, 0.3*size);
   rmAddObjectDefConstraint(farHuntableID, avoidTradeRoute);
   rmAddObjectDefConstraint(farHuntableID, avoidImportantItem);
   rmAddObjectDefConstraint(farHuntableID, avoidWater10);
   rmAddObjectDefConstraint(farHuntableID, fartherPlayerConstraint);
   rmAddObjectDefConstraint(farHuntableID, longHuntableConstraint);
   rmAddObjectDefConstraint(farHuntableID, avoidAll);
   rmSetObjectDefCreateHerd(farHuntableID, true);
   rmPlaceObjectDefPerPlayer(farHuntableID, false, 1);

// Lone elk
   int loneElkID=rmCreateObjectDef("lone elk");
   threeChoice = rmRandInt(1,3);
   if (threeChoice == 1)
      rmAddObjectDefItem(loneElkID, centerHerdType, rmRandInt(1,2), 3.0);
   else if (threeChoice == 2)
      rmAddObjectDefItem(loneElkID, deer2Type, rmRandInt(1,2), 3.0);
   else
      rmAddObjectDefItem(loneElkID, deerType, rmRandInt(1,2), 3.0);
   rmAddObjectDefToClass(loneElkID, rmClassID("huntableFood"));
   rmSetObjectDefMinDistance(loneElkID, 70.0);
   rmSetObjectDefMaxDistance(loneElkID, 0.4*size);
   rmAddObjectDefConstraint(loneElkID, longPlayerConstraint);
   rmAddObjectDefConstraint(loneElkID, shortAvoidImpassableLand);
   rmAddObjectDefConstraint(loneElkID, avoidNativesShort);
   rmAddObjectDefConstraint(loneElkID, huntableConstraint);
   rmAddObjectDefConstraint(loneElkID, avoidAll);
   rmSetObjectDefCreateHerd(loneElkID, true);
   rmPlaceObjectDefPerPlayer(loneElkID, false, 2);

   // Text
   rmSetStatusText("",0.90);

// Random trees
   int treeNum = cNumberNonGaiaPlayers*10;
   if (cNumberNonGaiaPlayers > 6)
	treeNum = cNumberNonGaiaPlayers*6;
   else if (cNumberNonGaiaPlayers > 5)
      treeNum = cNumberNonGaiaPlayers*7;
   else if (cNumberNonGaiaPlayers > 3)
      treeNum = cNumberNonGaiaPlayers*8;

   int StragglerTreeID=rmCreateObjectDef("stragglers");
   rmAddObjectDefItem(StragglerTreeID, treeType, 1, 0.0);
   rmAddObjectDefConstraint(StragglerTreeID, avoidAll);
   rmAddObjectDefConstraint(StragglerTreeID, avoidStartingUnitsSmall);
   rmAddObjectDefConstraint(StragglerTreeID, avoidCoin);
   rmAddObjectDefConstraint(StragglerTreeID, patchConstraint);
   rmAddObjectDefConstraint(StragglerTreeID, avoidWater10);
   rmSetObjectDefMinDistance(StragglerTreeID, 10.0);
   rmSetObjectDefMaxDistance(StragglerTreeID, rmXFractionToMeters(0.5));
   for(i=0; <treeNum)
      rmPlaceObjectDefAtLoc(StragglerTreeID, 0, 0.5, 0.25);
   for(i=0; <treeNum)
      rmPlaceObjectDefAtLoc(StragglerTreeID, 0, 0.5, 0.75);

   rmSetObjectDefMaxDistance(StragglerTreeID, size);
   for(i=0; <treeNum)
      rmPlaceObjectDefAtLoc(StragglerTreeID, 0, 0.5, 0.5);

// Patch to cover forest floor in some patterns
if (coverUp == 1)
{
   int desertID = rmCreateArea("desert");
   rmSetAreaLocation(desertID, 0.5, 0.5); 
   rmSetAreaWarnFailure(desertID, false);
   rmSetAreaSize(desertID, 0.99, 0.99);
   rmSetAreaCoherence(desertID, 0.99);
   rmSetAreaMix(desertID, baseType);
   rmBuildArea(desertID);

   int desert2ID = rmCreateArea("desert 2");
   rmSetAreaLocation(desert2ID, 0.5, 0.5); 
   rmSetAreaWarnFailure(desert2ID, false);
   rmSetAreaSize(desert2ID, 0.99, 0.99);
   rmSetAreaCoherence(desert2ID, 0.99);
   rmSetAreaMix(desert2ID, baseType);
   rmBuildArea(desert2ID);
}

// Deco
   // Dirt patches for Carolina
   if (patternChance == 2)
   {
	if (variantChance == 2)
	{
	   for (i=0; <cNumberNonGaiaPlayers*8)   
         {
		int dirtPatchC=rmCreateArea("carolina dirt patch "+i);
		rmSetAreaWarnFailure(dirtPatchC, false);
		rmSetAreaSize(dirtPatchC, rmAreaTilesToFraction(190), rmAreaTilesToFraction(260));
		rmSetAreaTerrainType(dirtPatchC, "carolina\ground_grass4_car");
		rmAddAreaToClass(dirtPatchC, rmClassID("classPatch"));
		rmSetAreaMinBlobs(dirtPatchC, 3);
		rmSetAreaMaxBlobs(dirtPatchC, 5);
		rmSetAreaMinBlobDistance(dirtPatchC, 16.0);
		rmSetAreaMaxBlobDistance(dirtPatchC, 36.0);
		rmSetAreaCoherence(dirtPatchC, 0.0);
		rmSetAreaSmoothDistance(dirtPatchC, 10);
		rmAddAreaConstraint(dirtPatchC, shortAvoidImpassableLand);
		rmAddAreaConstraint(dirtPatchC, patchConstraint);
	      rmAddAreaConstraint(dirtPatchC, shortForestConstraint);
		rmBuildArea(dirtPatchC); 
	   }
      }
   }

   // Patches for Great Plains
   if (patternChance == 8)
   {
      for (i=0; <cNumberNonGaiaPlayers*11)   
      {
	   int gpPatch=rmCreateArea("GP patch "+i);
	   rmSetAreaWarnFailure(gpPatch, false);
	   rmSetAreaSize(gpPatch, rmAreaTilesToFraction(180), rmAreaTilesToFraction(260));
	   rmSetAreaTerrainType(gpPatch, "great_plains\ground6_gp");
	   rmAddAreaToClass(gpPatch, rmClassID("classPatch"));
	   rmSetAreaMinBlobs(gpPatch, 1);
	   rmSetAreaMaxBlobs(gpPatch, 3);
	   rmSetAreaMinBlobDistance(gpPatch, 16.0);
	   rmSetAreaMaxBlobDistance(gpPatch, 36.0);
	   rmSetAreaCoherence(gpPatch, 0.0);
	   rmSetAreaSmoothDistance(gpPatch, 10);
	   rmAddAreaConstraint(gpPatch, shortAvoidImpassableLand);
	   rmAddAreaConstraint(gpPatch, patchConstraint);
	   rmBuildArea(gpPatch); 
      }

      for (i=0; <cNumberNonGaiaPlayers*30)   
      {
	   int gpPatch3=rmCreateArea("GP patch 3"+i);
	   rmSetAreaWarnFailure(gpPatch3, false);
	   rmSetAreaSize(gpPatch3, rmAreaTilesToFraction(50), rmAreaTilesToFraction(90));
	   if (rmRandInt(1,2) == 1)
	      rmSetAreaTerrainType(gpPatch3, "great_lakes\ground_grass4_gl");
	   else
	      rmSetAreaTerrainType(gpPatch3, "great_lakes\ground_grass5_gl");
	   rmAddAreaToClass(gpPatch3, rmClassID("classPatch"));
	   rmSetAreaMinBlobs(gpPatch3, 2);
	   rmSetAreaMaxBlobs(gpPatch3, 4);
	   rmSetAreaMinBlobDistance(gpPatch3, 5.0);
	   rmSetAreaMaxBlobDistance(gpPatch3, 12.0);
	   rmSetAreaCoherence(gpPatch3, 0.3);
	   rmSetAreaSmoothDistance(gpPatch3, 10);
	   rmAddAreaConstraint(gpPatch3, shortAvoidImpassableLand);
	   rmAddAreaConstraint(gpPatch3, patchConstraint);
	   rmBuildArea(gpPatch3); 
      }

	int grassPatchGroupType=-1;
	int grassPatchGroup=-1;
	for(i=1; <17*cNumberNonGaiaPlayers)
      {
		grassPatchGroupType=rmRandInt(1, 7);
		grassPatchGroup=rmCreateGrouping("Grass Patch Group"+i, "gp_grasspatch0"+grassPatchGroupType);
		rmSetGroupingMinDistance(grassPatchGroup, 0.0);
		rmSetGroupingMaxDistance(grassPatchGroup, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(grassPatchGroup, avoidImpassableLand);
		rmAddGroupingConstraint(grassPatchGroup, playerConstraint);
		rmAddGroupingConstraint(grassPatchGroup, avoidTradeRoute);
		rmAddGroupingConstraint(grassPatchGroup, avoidSocket);
		rmAddGroupingConstraint(grassPatchGroup, avoidNatives);
		rmAddGroupingConstraint(grassPatchGroup, avoidNuggetSmall);
		rmAddGroupingConstraint(grassPatchGroup, circleConstraint);
		rmAddGroupingConstraint(grassPatchGroup, avoidStartingUnits);
		rmAddGroupingConstraint(grassPatchGroup, avoidAll);
		rmAddGroupingConstraint(grassPatchGroup, avoidCliffs);
		rmPlaceGroupingAtLoc(grassPatchGroup, 0, 0.5, 0.5, 1);
	}

	int flowerPatchGroupType=-1;
	int flowerPatchGroup=-1;
	for(i=1; <15*cNumberNonGaiaPlayers)
      {
		flowerPatchGroupType=rmRandInt(1, 8);
		flowerPatchGroup=rmCreateGrouping("Flower Patch Group"+i, "gp_flower0"+flowerPatchGroupType);
		rmSetGroupingMinDistance(flowerPatchGroup, 0.0);
		rmSetGroupingMaxDistance(flowerPatchGroup, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(flowerPatchGroup, avoidImpassableLand);
		rmAddGroupingConstraint(flowerPatchGroup, playerConstraint);
		rmAddGroupingConstraint(flowerPatchGroup, avoidTradeRoute);
		rmAddGroupingConstraint(flowerPatchGroup, avoidSocket);
		rmAddGroupingConstraint(flowerPatchGroup, avoidNatives);
		rmAddGroupingConstraint(flowerPatchGroup, avoidNuggetSmall);
		rmAddGroupingConstraint(flowerPatchGroup, avoidAll);
		rmAddGroupingConstraint(flowerPatchGroup, avoidCliffs);
		rmAddGroupingConstraint(flowerPatchGroup, circleConstraint);
		rmAddGroupingConstraint(flowerPatchGroup, avoidStartingUnits);
		rmPlaceGroupingAtLoc(flowerPatchGroup, 0, 0.5, 0.5, 1);
	}
   }

   if (plainsMap == 1)
   {
	int areThereBuffalo=rmRandInt(1, 2);
	int howManyBuffalo=rmRandInt(2, 3);
	if ( areThereBuffalo == 1 )
	{
		int bisonCarcass=rmCreateGrouping("Bison Carcass", "gp_carcass_bison");
		rmSetGroupingMinDistance(bisonCarcass, 0.0);
		rmSetGroupingMaxDistance(bisonCarcass, rmXFractionToMeters(0.5));
		rmAddGroupingConstraint(bisonCarcass, avoidImpassableLand);
		rmAddGroupingConstraint(bisonCarcass, playerConstraint);
		rmAddGroupingConstraint(bisonCarcass, avoidTradeRoute);
		rmAddGroupingConstraint(bisonCarcass, avoidSocket);
		rmAddGroupingConstraint(bisonCarcass, avoidStartingUnits);
		rmAddGroupingConstraint(bisonCarcass, avoidAll);
		rmAddGroupingConstraint(bisonCarcass, avoidNuggetSmall);
		rmPlaceGroupingAtLoc(bisonCarcass, 0, 0.5, 0.5, howManyBuffalo);
	}
   }

   if (patternChance == 10) // Texas desert
   {
	int bigDecorationID=rmCreateObjectDef("Big Texas Things");
	int avoidBigDecoration=rmCreateTypeDistanceConstraint("avoid big decorations", "BigPropTexas", 45.0);
	rmAddObjectDefItem(bigDecorationID, "BigPropTexas", 1, 0.0);
	rmSetObjectDefMinDistance(bigDecorationID, 0.0);
	rmSetObjectDefMaxDistance(bigDecorationID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(bigDecorationID, avoidAll);
	rmAddObjectDefConstraint(bigDecorationID, avoidImportantItem);
	rmAddObjectDefConstraint(bigDecorationID, avoidCoin);
	rmAddObjectDefConstraint(bigDecorationID, avoidImpassableLand);
	rmAddObjectDefConstraint(bigDecorationID, avoidBigDecoration);
	rmAddObjectDefConstraint(bigDecorationID, avoidCliffs);
	rmAddObjectDefConstraint(bigDecorationID, longPlayerConstraint);
	rmPlaceObjectDefAtLoc(bigDecorationID, 0, 0.5, 0.5, rmRandInt(2,4));
   }

   if (vultures == 1)
   { 
	int vultureID=rmCreateObjectDef("perching vultures");
	int avoidVultures=rmCreateTypeDistanceConstraint("avoid other vultures", "PropVulturePerching", 30.0);
	rmAddObjectDefItem(vultureID, "PropVulturePerching", 1, 0.0);
	rmSetObjectDefMinDistance(vultureID, 0.0);
	rmSetObjectDefMaxDistance(vultureID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(vultureID, avoidAll);
	rmAddObjectDefConstraint(vultureID, avoidImportantItem);
	rmAddObjectDefConstraint(vultureID, avoidCoin);
	rmAddObjectDefConstraint(vultureID, avoidImpassableLand);
	rmAddObjectDefConstraint(vultureID, avoidTradeRoute);
	rmAddObjectDefConstraint(vultureID, avoidCliffs);
	rmAddObjectDefConstraint(vultureID, avoidVultures);
	rmAddObjectDefConstraint(vultureID, avoidWater20);
	rmAddObjectDefConstraint(vultureID, longPlayerConstraint);
	rmPlaceObjectDefAtLoc(vultureID, 0, 0.5, 0.5, 2);
      if (cNumberNonGaiaPlayers > 4)
	   rmPlaceObjectDefAtLoc(vultureID, 0, 0.5, 0.5, 1);

	int buzzardFlockID=rmCreateObjectDef("buzzards");
	int avoidBuzzards=rmCreateTypeDistanceConstraint("buzzard avoid buzzard", "BuzzardFlock", 70.0);
	rmAddObjectDefItem(buzzardFlockID, "BuzzardFlock", 1, 3.0);
	rmSetObjectDefMinDistance(buzzardFlockID, 0.0);
	rmSetObjectDefMaxDistance(buzzardFlockID, rmXFractionToMeters(0.3));
	rmAddObjectDefConstraint(buzzardFlockID, avoidBuzzards);
	rmAddObjectDefConstraint(buzzardFlockID, avoidSocket);
	rmAddObjectDefConstraint(buzzardFlockID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(buzzardFlockID, playerConstraint);
	rmPlaceObjectDefAtLoc(buzzardFlockID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
   }

   if (eagles == 1)
   {
	int avoidEagles=rmCreateTypeDistanceConstraint("avoids Eagles", "EaglesNest", 40.0);
	int randomEagleTreeID=rmCreateObjectDef("random eagle tree");
	rmAddObjectDefItem(randomEagleTreeID, "EaglesNest", 1, 0.0);
	rmSetObjectDefMinDistance(randomEagleTreeID, 0.0);
	rmSetObjectDefMaxDistance(randomEagleTreeID, rmXFractionToMeters(0.5));
	rmAddObjectDefConstraint(randomEagleTreeID, avoidAll);
	rmAddObjectDefConstraint(randomEagleTreeID, shortAvoidImpassableLand);
	rmAddObjectDefConstraint(randomEagleTreeID, avoidEagles);
	rmPlaceObjectDefAtLoc(randomEagleTreeID, 0, 0.5, 0.5, 2);
      if (cNumberNonGaiaPlayers > 4)
	   rmPlaceObjectDefAtLoc(randomEagleTreeID, 0, 0.5, 0.5, 1);
   }
   
   if (patternChance == 14) // Pampas
   {
      for (i=0; <12*cNumberNonGaiaPlayers)
      {
         int pampasPatch=rmCreateArea("pampas patch "+i);
         rmSetAreaWarnFailure(pampasPatch, false);
         rmAddAreaToClass(pampasPatch, rmClassID("classPatch"));
	   if (cliffVariety < 3) // not used for cliffs!
	   {
		rmSetAreaSize(pampasPatch, rmAreaTilesToFraction(200), rmAreaTilesToFraction(300));
		rmSetAreaTerrainType(pampasPatch, "pampas\ground6_pam");
	   }
	   else
	   {
		rmSetAreaSize(pampasPatch, rmAreaTilesToFraction(300), rmAreaTilesToFraction(400));
		rmSetAreaMix(pampasPatch, "pampas_grass");
	      rmAddAreaConstraint(pampasPatch, shortForestConstraint);
	   }
         rmSetAreaMinBlobs(pampasPatch, 1);
         rmSetAreaMaxBlobs(pampasPatch, 5);
         rmSetAreaMinBlobDistance(pampasPatch, 14.0);
         rmSetAreaMaxBlobDistance(pampasPatch, 38.0);
         rmSetAreaCoherence(pampasPatch, 0.1);
	   rmSetAreaSmoothDistance(pampasPatch, 10);
	   rmAddAreaConstraint(pampasPatch, shortAvoidImpassableLand);
	   rmAddAreaConstraint(pampasPatch, patchConstraint);
         rmBuildArea(pampasPatch); 
      }

	int avoidBrush=rmCreateTypeDistanceConstraint("avoids brush", "UnderbrushPampas", 30.0);
	int decoUnderbrushID=rmCreateObjectDef("underbrush");
	rmAddObjectDefItem(decoUnderbrushID, "UnderbrushPampas", rmRandInt(4,6), 3.0);
	rmSetObjectDefMinDistance(decoUnderbrushID, 20.0);
	rmSetObjectDefMaxDistance(decoUnderbrushID, rmXFractionToMeters(0.5));
      rmAddObjectDefConstraint(decoUnderbrushID, avoidAll);
	rmAddObjectDefConstraint(decoUnderbrushID, avoidImpassableLand);
	rmAddObjectDefConstraint(decoUnderbrushID, playerConstraint);
	rmAddObjectDefConstraint(decoUnderbrushID, avoidBrush);
	rmAddObjectDefConstraint(decoUnderbrushID, avoidTradeRoute);
      rmPlaceObjectDefAtLoc(decoUnderbrushID, 0, 0.5, 0.5, 14*cNumberNonGaiaPlayers);
   }

   if (patternChance == 16) // andes
   {
	// Deco for Andes - Puyas
	int puyaCount = (cNumberNonGaiaPlayers*3);
	for (i=0; <puyaCount)
	{   
		int puyaTreeID= rmCreateObjectDef("puya tree"+i); 
		rmAddObjectDefItem(puyaTreeID, "treePuya", 1, 0.0);
		rmAddObjectDefConstraint(puyaTreeID, shortAvoidImpassableLand);
  		rmAddObjectDefConstraint(puyaTreeID, avoidNugget);
  		rmAddObjectDefConstraint(puyaTreeID, avoidTradeRoute);
		rmAddObjectDefConstraint(puyaTreeID, mediumPlayerConstraint);
  		rmAddObjectDefConstraint(puyaTreeID, avoidAll);
		rmAddObjectDefConstraint(puyaTreeID, avoidCliffs);
		rmAddObjectDefConstraint(puyaTreeID, playerEdgeConstraint);
		rmPlaceObjectDefAtLoc(puyaTreeID, 0, 0.5, 0.5);
	}
   }

   // Patches for Araucania, California
   if (specialPatch == 1)
   {
      for (i=0; <cNumberNonGaiaPlayers*8)   
      {
	   int colorPatch=rmCreateArea("color patch "+i);
	   rmSetAreaWarnFailure(colorPatch, false);
	   rmSetAreaSize(colorPatch, rmAreaTilesToFraction(300), rmAreaTilesToFraction(450));
         rmSetAreaMix(colorPatch, patchMixType);
	   rmAddAreaToClass(colorPatch, rmClassID("classPatch"));
	   rmSetAreaMinBlobs(colorPatch, 1);
	   rmSetAreaMaxBlobs(colorPatch, 3);
	   rmSetAreaMinBlobDistance(colorPatch, 16.0);
	   rmSetAreaMaxBlobDistance(colorPatch, 36.0);
	   rmSetAreaCoherence(colorPatch, 0.0);
	   rmSetAreaSmoothDistance(colorPatch, 10);
	   rmAddAreaConstraint(colorPatch, shortAvoidImpassableLand);
	   rmAddAreaConstraint(colorPatch, patchConstraint);
	   rmAddAreaConstraint(colorPatch, avoidWater20);
	   rmAddAreaConstraint(colorPatch, shortForestConstraint);
	   rmBuildArea(colorPatch); 
      }
   }
}  

  

